// NavigateCalculations.h
//
// header file for NavigateCalculations
//
//
// Copyright (c) 2005 Rick Chapman.
// All rights reserved.



// ********************************************************************
// Global variables
// ********************************************************************

#define kMaxMantissaDigits	8		// max digits in display value, NOT including decimal
#define pi 3.14159265358979326433
#define FOURTHPI  (pi/4.0)
#define deg2rad  (pi/180.0)
#define rad2deg  (180.0/pi)


// ********************************************************************
// Wave Calculation Functions
// ********************************************************************

void GeoRangeAndBearing(double lat1, double lng1, double lat2, double lng2, double *range, double *bearing) ;
void GeoLine(double lat1, double lng1, double bearing, double range, double *lat2, double *lng2) ;
void LoxoRangeAndBearing(double lat1, double lng1, double lat2, double lng2, double *range, double *bearing) ;
void LoxoLine(double lat1, double lng1, double bearing, double range, double *lat2, double *lng2) ;
void MaxLoxoLine(double lat1, double lng1, double bearing, double *range, double *lat2, double *lng2) ;

