#include "main.h" 
#include "NavigateCalculations.h"
#include "utils.h"
#include "font.h"
#include "attractions.h"
#include "nmeap.h"
#include "danzeff.h"
#include <mad.h>	// MIB.42_7
#include <stdarg.h>
extern int zipcounter;
extern ADDRESS addrs[MAXZIP];
extern int MP3_playing;
extern int reverse_lookup(double lat, double lon, char * streetbuf, char * zipfile);
extern int resolve(char *, double *, double *);
extern int address_geolookup2( char * zipfile, char *addr, char* zip, char * city_filter, char * state_filter , double minlat, double minlon, double maxlat, double maxlon, int tolerance);
extern void MP3_Play(char *name, int offset);
// MIB.42_7
int	MP3_module_start(SceSize args, void *argp);
void	MP3_ProcessM3U(char *name);				// calling this with NULL will free the list
void	MP3_PlaySnipet(char *name);

void	MP3_Stop(void);
void	MP3_Pause(int pause);	// 0 to continue, 1 to pause
int running=1;
// EoF MIB.42_7


int my_access1(char *name,int ok) { //mimic after access()
	FILE * f=fopen (name,"r");
	if (f==NULL)
		return -1;
	else {
		fclose(f);
		return 0;
	}
}
int my_access(char *name,int ok) { //mimic after access()
	FILE * f=fopn (name,"r");
	if (f==NULL)
		return -1;
	else {
		fclose(f);
		return 0;
	}
}
 

void display_message(char* line1, char* line2, char* line3, int timeout); 
int baud=38400;
int turnspeed=0;
int framecounter=1;
int avgframes=1;
int togglefeed=0;
int gotGpsData=0;
int isconnected=0;
int fakefeed=0;
int dms=0;
int debug_logging=0;
int cachedelay=0;
int checksum=0;
double speedfix=1.151;
double speedlimit=0;
int nightmode=0;
double altfix=1;
int warn_dist=50;
double speedfactor=0.95;
int timezone=0;
char startupmap[64];
char streetbuf[128];
int displaycounter=0;
int rotatemap=0;
int Clock=333;
int showpanels=1;
int ffreadspeed=1;
u64 triptime=0;
FILE *gpsout=NULL;
SceUID wifithid=0;
extern ATTRACTION * attractions[MAXNUM];
#define EVENT_SIO       0x01
SceCtrlData cpad;
Image * current, *attraction[MAXIMAGE], *rotimage, *messageplate, *blank=NULL ;
SceUID thid_wifi=0,thid_cachemngr=0,thid_garbagecoll=0,thid_usermain=0; 
#ifndef GENERIC
SceUID thid_gpsmngr=0; 
#endif


int TILE_NUM;
int zoom ;
int zm;
int gpsOn=0;
int basezoom=2;
int mapsize;
char dirname[128];
int maxzoom;
int oldzoom;
long mapx ;
long mapy ;
int killwifi=0;
int loadwifi=1;
int startupfrequency=333;
int satinfofrequency=100;
double mx,my;
double lat=0;
double lon=0;
double deltax=0;
double deltay=0;
double oldx=0;
double oldy=0;
double bearing=0;
char zipfile[100];
char filetype[8];
char messages [16][60];
int messagecount=0;
int tlock=0;
#define MAXLISTSIZE 100
char options[MAXLISTSIZE][60];

int pathx[PATHMAX];
int pathy[PATHMAX];
int pathcounter;
char attr_file[64];


char heading[8][3] = { " N", "NE", " E", "SE", " S", "SW", " W", "NW" };
int optcount=0;
int datatype=0;         // 0=dir; 1=zipfile

double lat1, lon1;
double curlat, curlon, pathdist;
int mapx1, mapy1;
int marker=0;
double ftx, fty;
int firsttime=1;
int idle=0; //???

int attr_flag=0;
int waypoint=0;
int cachemapindex=0;
char attr_ifile[MAXIMAGE][128];
int attr_width=16;
int attr_height=8;
FILE * fp;
int gpsdone=0;
u64 currTick;
u64 routeTick;
u64 deltatime;
u64 frameTick;
u64 frameDelta;



// TODO: should be moved to PSPSDK
int sceNetResolverCreate(int *rid, void *buf, SceSize buflen);
int sceNetResolverStartNtoA(int rid, const char* hostname, struct in_addr* addr, unsigned int timeout, int retry);
int sceNetResolverStartAtoN(int rid, const struct in_addr* addr, char *hostname, SceSize hostname_len, unsigned int timeout, int retry);
int sceNetResolverStop(int rid);
int sceNetInetInetAton(const char* host, struct in_addr* addr);
static void cleanup_output(void);

static char resolverBuffer[1024];
static int resolverId;

Coord getGPS (int x, int y); 
Coord getTileCoord(double lat, double lon, int zoomLevel ); 


static  double pixelsPerLonDegree[20];
static  double pixelsPerLonRadian[20];
static  double numTiles[20];
static  double bitmapOrigo[20];
static  double bc = 2 * PI;
static  double Wa = PI / 180;



int status=0;

Coord c;
double        altitude;
unsigned long ltime;
int           satellites;
int           satellites_in_view;
int           quality;
double        hdop;
double        geoid;
char          warn[4]="---";


double        latitude;
double        longitude;
double        prevlat=0;
double        prevlon=0;
double        speed;
double        avgspeed=0;
double        distance=0;
double        course;
double        course1;
unsigned long date;
double        magvar;

long initLocation=0;

#ifndef GENERIC

PSP_MODULE_INFO("Google Map Viewer", 0, 1, 0);
//PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);

#define printf  pspDebugScreenPrintf
gpsdata gpsd;
satdata  satd;
int usbthread=0;
u32 usbState = 0, gpsState = 0;
long getLocation=0;

int main_thread (SceSize args, void *argp);
int module_start (SceSize args, void *argp)
{
 SceUID thid;


 thid = sceKernelCreateThread("main_thread",main_thread,33,64*1024,0,0);
 if (thid >= 0) sceKernelStartThread(thid,args,argp);

 return 0;
}


u32 moduleLoadStart (const char *name)
{
 SceUID loadResult, startResult;
 int status;
 char path[128];

 sprintf(path,"%s/%s",currentpath,name);
ms_write_log("\nmoduleLoadStart : loading '%s'",path);
 loadResult = sceKernelLoadModule(path,0,NULL);
ms_write_log("\nmoduleLoadStart : loadResult = %x",loadResult);
 if (loadResult & 0x80000000) return 1;

ms_write_log("\nmoduleLoadStart : calling sceKernelStartModule");
 startResult = sceKernelStartModule(loadResult,0,NULL,&status,NULL);
ms_write_log("\nmoduleLoadStart : startResult = %x",startResult);
 if (loadResult != startResult) return 2;

 return 0;
}


int gpsmngr (SceSize args, void *argp) {
        memset(&gpsd,0x0,sizeof(gpsd));
        memset(&satd,0,sizeof(satd));
        sceUsbActivate(PSP_USBGPS_PID);
        double prevlat=0, prevlon=0;
	short	      prevsecond=0;
        double curlat=0, curlon=0;
        sceUsbGpsSetInitDataLocation(initLocation);

       while (running) {

	if (fakefeed) {
		int bytes=1;
		fp=fopn("gps.txt","r");
		while (bytes>0) {
			if (fp!=NULL) {
                	bytes=fread (&gpsd,48,1,fp);
                	curlat=gpsd.latitude;
                	curlon=gpsd.longitude;

                	if (curlat!=0.00 && curlon!=0.0) {
                        	if (prevlat!=0.00 && prevlon!=0.00) {
                                	double rng=0;
                                	double bearing=0;
                                	GeoRangeAndBearing(curlat, curlon, prevlat,prevlon, &rng, &bearing) ;
                                	if (rng<10000 && rng >-10000)
                                        	distance+=rng;
                        	}
                        	prevlat=curlat;
                        	prevlon=curlon;
                	}
			}

			if (togglefeed==1) {
                 		togglefeed=0;
                      		break;
                	}
        		if (usbthread>0)
                		break;
			gotGpsData=1;
			sceKernelDelayThread(1000000);
		}
		if (fp!=NULL)
			fclose(fp);
	}else{
		while (running) {
        	usbState = sceUsbGetState();
        	// Get state of GPS
        	if (usbState & PSP_USB_ACTIVATED)
                	sceUsbGpsGetState(&gpsState);
        	else
                	gpsState = 0;

        	getLocation=0;
        	memset(&gpsd,0x0,sizeof(gpsd));
        	memset(&satd,0,sizeof(satd));
        	// Get data of GPS
        	if (gpsState == 0x3) {
                	sceUsbGpsGetData(&gpsd,&satd);
                	sceUsbGpsGetInitDataLocation(&getLocation);
                	curlat=gpsd.latitude;
                	curlon=gpsd.longitude;

                	if (curlat!=0.00 && curlon!=0.00) {
                        	if (prevlat!=0.00 && prevlon!=0.00) {
                                	double bearing=0;
                               		double range=0;
                                	GeoRangeAndBearing(curlat, curlon, prevlat,prevlon, &range, &bearing) ;
                                	if (range<10000 && range >-10000)
                                        	distance+=range;
                        		}
					if (gpsd.second!=prevsecond)
						gotGpsData=1;
                        		prevlat=curlat;
                        		prevlon=curlon;
					prevsecond=gpsd.second;
                	}
		}
		if (gpsout!=NULL)
        		fwrite(&gpsd,48,1,gpsout);
        	if (usbthread>0)
                	break;
	
		if (togglefeed==1) {
                        togglefeed=0;
                        break;
                }
        	sceKernelDelayThread(1000);

        	}
	}

       	if (usbthread>0)
               	break;
   }

        return 1;
}

void getGPSMessage() {

        Coord xy_coord;
        framecounter++;

        latitude=gpsd.latitude;
        longitude=gpsd.longitude;
        altitude=gpsd.altitude;
        speed=gpsd.speed/1.8523;
        hdop=gpsd.hdop;

        if (speed>turnspeed) {
                if (abs(course-gpsd.bearing)>180) {
                        if (course > 180)
                                course=course-360;
                        if (gpsd.bearing>180)
                               gpsd.bearing=gpsd.bearing-360;
                }
                course=(course+gpsd.bearing)/2;
                if (course <0)
                        course=course+360;
       }
        ltime=gpsd.hour*10000+gpsd.minute*100+gpsd.second;
        int j;
        int fix=0;
        for (j=0; j<satd.satellites_in_view; j++) {
                if ( satd.satinf[j].good==1)
                        fix++;
        }
        satellites=fix;

        u64 newTick;
        sceRtcGetCurrentTick(&newTick);
        if (gotGpsData==0)
                return;

        currTick=newTick;

        avgframes=framecounter;
	//fprintf(stdout, "[%d]\n",avgframes);
        framecounter=1;
	gotGpsData=0;
        if (latitude==0.0 || longitude==0.0) {
                strcpy(warn,"BAD");
                return;
        }
        strcpy(warn,"OK");
        xy_coord=getXY(latitude, longitude, basezoom);
        if (xy_coord.lon>0 && xy_coord.lon<TILE_SIZE*TILE_NUM && xy_coord.lat>0 && xy_coord.lat<TILE_SIZE*TILE_NUM) {
                mapx=(int)xy_coord.lon;
                mapy=(int)xy_coord.lat;
                mx=mapx;
                my=mapy;
                deltax=mapx-oldx;
                deltay=mapy-oldy;
                oldx=mapx;
                oldy=mapy;
		u64 curTick;
                sceRtcGetCurrentTick(&curTick);
                curTick=(curTick-triptime)/1000000;
                avgspeed=(double)(distance/curTick)*3.6*speedfix*0.53986935161690870809264158073746;

           } else {
                char locstr[32];
                sprintf(locstr,"%.5f::%.5f", latitude, longitude);
               display_message("LOCATION OUT OF RANGE !!!","THIS MAP DOES NOT COVER FOLLOWING COORDS:",locstr,500);
        }

}

#else

PSP_MODULE_INFO("MapThis!", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);
static SceUID g_eventflag = -1;
static int             user_data; 
nmeap_gga_t g_gga;
static nmeap_context_t nmea;
static nmeap_gga_t     gga;
static nmeap_rmc_t     rmc;
static nmeap_gsv_t     gsv;

int shownmea=0;
char buffer[1024];

//filters out unused sentenses
void nmea_filter(char * src) {
	char tmp[1024];
	strcpy(tmp, src);
	memset(src,0,1024);
	char * p = strtok(tmp,"\n");
	while (p!=NULL) {
		if (strlen(p)>40 && strstr(p,"$GPVTG")==NULL && strstr(p,"$GPGSA")==NULL) {
			strcat(src,p);
			strcat(src,"\n");
		}
		p=strtok(NULL,"\n");
	}
}


static void print_gga(nmeap_gga_t *gga)
{
            latitude=gga->latitude; 
            longitude=gga->longitude;
            altitude=gga->altitude , 
            ltime=gga->time; 
            satellites=gga->satellites;
            quality=gga->quality; 
            hdop=gga->hdop;
            geoid=gga->geoid;  
		//fprintf(stdout,"gga\n");
}


static void print_gsv(nmeap_gsv_t *gsv) {
	satellites_in_view= gsv->satellites_in_view;
	//fprintf(stdout,"gsv::%d\n", satellites_in_view);
}

static void print_rmc(nmeap_rmc_t *rmc)
{
	    //fprintf(stdout,"rmc %f\n",rmc->latitude);
            ltime=rmc->time;
	    if (rmc->warn=='A')
            	strcpy(warn, "OK ");
	    else
            	strcpy(warn, "BAD");
            latitude=rmc->latitude;
            longitude=rmc->longitude;
            speed=rmc->speed;
	    course1=rmc->course;
            date=rmc->date;
            magvar=rmc->magvar;
  	    gotGpsData=1;
	  //  fprintf(stdout,"print_rmc:: %10.6f::%10.6f\n", latitude, longitude);
		if (prevlat!=0.00 && prevlon!=0.00) {
                                double rng=0;
                                double bearing=0;
                                GeoRangeAndBearing(latitude, longitude, prevlat,prevlon, &rng, &bearing) ;
                                if (rng<10000 && rng >-10000)
                                        distance+=rng;
                 }
                 prevlat=latitude;
                 prevlon=longitude;
}
static void gpgsv_callout(nmeap_context_t *context,void *data,void *user_data)
{
    nmeap_gsv_t *gsv = (nmeap_gsv_t *)data;
   
    print_gsv(gsv);
}


/** called when a gprmc message is received and parsed */
static void gprmc_callout(nmeap_context_t *context,void *data,void *user_data)
{
    nmeap_rmc_t *rmc = (nmeap_rmc_t *)data;
    print_rmc(rmc);
}

/** called when a gpgga message is received and parsed */
static void gpgga_callout(nmeap_context_t *context,void *data,void *user_data)
{
    nmeap_gga_t *gga = (nmeap_gga_t *)data;
    print_gga(gga);
}
int user_main (SceSize args, void *argp); 

void getGPSMessage() {

        Coord xy_coord;
	framecounter++;
        if (speed>turnspeed) {
                if (fabs(course-course1)>180) {
                        if (course > 180)
                                course=course-360;
                        if (course1>180)
                               course1=course1-360;
                }
                course=(course+course1)/2;
                if (course <0)
                        course=course+360;
       }

        u64 newTick;
        sceRtcGetCurrentTick(&newTick);
        //if (newTick-currTick<999999)
        if (gotGpsData==0)
                return;
	avgframes=framecounter;
	//printf("avgframes=%d\n",avgframes);
	framecounter=1;
        currTick=newTick;
	gotGpsData=0;

	if (warn[0]!='O')
                return;

        xy_coord=getXY(latitude, longitude, basezoom);
        if (xy_coord.lon>0 && xy_coord.lon<TILE_SIZE*TILE_NUM && xy_coord.lat>0 && xy_coord.lat<TILE_SIZE*TILE_NUM) {
                mapx=(int)xy_coord.lon;
                mapy=(int)xy_coord.lat;
                mx=mapx;
                my=mapy;
                deltax=((double)mapx-oldx);
                deltay=((double)mapy-oldy);
                oldx=mapx;
                oldy=mapy;
		u64 curTick;
		sceRtcGetCurrentTick(&curTick);
		curTick=(curTick-triptime)/1000000;
		avgspeed=(double)(distance/curTick)*3.6*speedfix*0.53986935161690870809264158073746;
	//printf("deltax=%4.2f delta=%4.2f avgframes=%d %ld:%ld\n",deltax,deltax/avgframes,avgframes, mapx,mapy);	
	//printf("deltay=%4.2f delta=%4.2f avgframes=%d %ld:%ld\n",deltay,deltay/avgframes,avgframes, mapx,mapy);	
           } else {
                char locstr[32];
                sprintf(locstr,"%.5f::%.5f", latitude, longitude);
               display_message("LOCATION OUT OF RANGE !!!","THIS MAP DOES NOT COVER FOLLOWING COORDS:",locstr,100);
        }

}

void sioSetBaud(int baud)
{
        int div1, div2;

        /* rate set using the rough formula div1 = (PSP_UART_CLK / baud) >> 6 and
         * div2 = (PSP_UART_CLK / baud) & 0x3F
         * The uart4 driver actually uses a slightly different formula for div 2 (it
         * adds 32 before doing the AND, but it doesn't seem to make a difference
         */
        div1 = PSP_UART_CLK / baud;
        div2 = div1 & 0x3F;
        div1 >>= 6;

        _sw(div1, PSP_UART4_DIV1);
        _sw(div2, PSP_UART4_DIV2);
        _sw(0x60, PSP_UART4_CTRL);
}


static void _sioInit(void)
{
        /* Shut down the remote driver */
        sceHprmEnd();
        /* Enable UART 4 */
        sceSysregUartIoEnable(4);
        /* Enable remote control power */
        //sceSyscon_driver_44439604(1);
        sceSysconCtrlHRPower(1);
}


static int intr_handler(void *arg)
{
        u32 stat;

        /* Read out the interrupt state and clear it */
        stat = _lw(0xBE500040);
        _sw(stat, 0xBE500044);

        sceKernelDisableIntr(PSP_HPREMOTE_INT);

        sceKernelSetEventFlag(g_eventflag, EVENT_SIO);

        return -1;
}

void sioInit(int baud, int kponly)
{
        _sioInit();
        if(!kponly)
        {
                g_eventflag = sceKernelCreateEventFlag("SioShellEvent", 0, 0, 0);
                void *func = (void *) ((unsigned int) intr_handler | 0x80000000); 
                int st=sceKernelRegisterIntrHandler(PSP_HPREMOTE_INT, 1, func, NULL, NULL);
                //fprintf(stdout,"sceKernelRegisterIntrHandler::%d\n",st);
                st=sceKernelEnableIntr(PSP_HPREMOTE_INT);
                //fprintf(stdout,"sceEnableIntr::%d\n",st);
                /* Delay thread for a bit */
                sceKernelDelayThread(2000000);
        }
        sioSetBaud(baud);
}




int sioReadChar(void)
{
        int ch;
        u32 result;
         SceUInt timeout;

        timeout = 100000;
        ch = pspDebugSioGetchar();
        if(ch == -1)
        {
                sceKernelEnableIntr(PSP_HPREMOTE_INT);
                sceKernelWaitEventFlag(g_eventflag, EVENT_SIO, 0x21, &result, &timeout);

                ch = pspDebugSioGetchar();
        }

        return ch;
}



#endif


void record_thread_info(SceUID thid)            // MIB.42_5
{
SceKernelThreadInfo     tinf;
char                    ts[2];

        if(thid<1) return;
        tinf.size = sizeof(SceKernelThreadInfo);
        if(sceKernelReferThreadStatus(thid, &tinf) == 0)
        {
                if(tinf.status==PSP_THREAD_RUNNING) {ts[0]='R';ts[1]='u';}
                else
                if(tinf.status==PSP_THREAD_READY) {ts[0]='R';ts[1]='d';}
                else
                if(tinf.status==PSP_THREAD_WAITING) {ts[0]='W';ts[1]='a';}
                else
                if(tinf.status==PSP_THREAD_SUSPEND) {ts[0]='S';ts[1]='u';}
                else
                if(tinf.status==PSP_THREAD_STOPPED) {ts[0]='S';ts[1]='t';}
                else
                if(tinf.status==PSP_THREAD_KILLED) {ts[0]='K';ts[1]='i';}
                else
                {ts[0]='U';ts[1]='n';}
                ms_write_log("ThreadInfo : '%s' = %c%c  stack=%p[%d]  ExitStat=%d  IntPCnt=%d ThrPCnt=%d  RelsCnt=%d\n",tinf.name,ts[0],ts[1],tinf.stack,tinf.stackSize,tinf.exitStatus,tinf.intrPreemptCount,tinf.threadPreemptCount,tinf.releaseCount);
        }
        else
                ms_write_log("Can not get thread info on %d\n",thid);
}



void initPath() {
	pathcounter=1;
	pathdist=0.00000;
	curlat=0;
	curlon=0;
	int i;
	for (i=0; i<PATHMAX; i++) {
		pathx[i]=-1;
		pathy[i]=-1;
	}
}


int opt_cmp(const void * a1, const void * a2) {
	return strcmp((char*)a1, (char*)a2); 
}

int attr_cmp(const void * a1, const void * a2) {
	ATTRACTION *attr1 = *(ATTRACTION **) a1;
	ATTRACTION *attr2 = *(ATTRACTION **) a2;
	//fprintf(stdout, "%f:::%f\n", attr1->d , attr2->d);
	return (int)(attr1->d - attr2->d); 
}

FILE * fopn (const char * path,const char* options) {
#ifdef GENERIC
        return fopen(path,options);
#else
        char fullname[256];
        sprintf(fullname,"%s/%s", currentpath,path);
        return fopen(fullname,options);
#endif
}


Image* ldImage(const char* filename) {
#ifdef GENERIC
	return loadImage(filename);
#else
        char fullname[256];
        sprintf(fullname,"%s/%s", currentpath,filename);
        return loadImage(fullname);
#endif
}

Image* ldImage1(const char* filename,int negate) {
#ifdef GENERIC
	return loadImage1(filename,negate);
#else
        char fullname[256];
        sprintf(fullname,"%s/%s", currentpath,filename);
        return loadImage1(fullname,negate);
#endif
}


void turn_on_attractions () {
			int attr_counter=load_attractions("_MY_POIS", zipfile, datatype,  mapx,  mapy, zoom, "");
			attr_counter=load_attractions(attr_file, zipfile, datatype,  mapx,  mapy, zoom, "");
		int k;	
		for ( k=0;k<=get_image_count(); k++) {
		//fprintf(stdout,"%d---->[%s]\n",get_image_count(),attr_ifile[k]);
		if (strlen(attr_ifile[k])==0)
                        attraction[k] = ldImage("system/icons/attraction.png");
                else {
                                char filename1[128];
                                sprintf(filename1,"%s/%s", zipfile,attr_ifile[k]);
				if (my_access(filename1, F_OK) != 0)
                               		sprintf(filename1,"system/icons/%s", attr_ifile[k]);
				if (my_access(filename1, F_OK) != 0)
                               		sprintf(filename1,"system/icons/attraction.png");
                                attraction[k]=ldImage(filename1);
                }
		}
		attr_flag=1;
}

void turn_off_attractions() {
	int i;
	attr_flag=0;
		for ( i=1; i<MAXIMAGE; i++) {
			if (attraction[i]!=NULL)
				freeImage(attraction[i]);	
			attraction[i]=NULL;
		}
	free_attractions();
}

void freeup100points() {
	int i;
	for( i=100; i<PATHMAX; i++) {
		pathx[i-100]=pathx[i];
		pathy[i-100]=pathy[i];
	}

	for (i=PATHMAX-100; i<PATHMAX; i++){
		pathx[i]=-1;
		pathy[i]=-1;
	}
	pathcounter-=100;

}

void addPathPoint(long x, long y) {
	marker=1;
	Coord c=getGPS(x,y);
	//printf("%ld:%ld,%ld      %f:%f\n",x+ftx,y+fty,basezoom,c.lat,c.lon);
	lat1=c.lat;
	lon1=c.lon;
	mapx1=x;
	mapy1=y;
	if (attraction[0]==NULL)
		attraction[0] = ldImage("system/icons/attraction.png");
	if (pathcounter>=PATHMAX-1)
		freeup100points();
		pathx[pathcounter]=x;
		pathy[pathcounter]=y;
		pathcounter++;
}

void readPath() {
	if ((cpad.Buttons &  PSP_CTRL_CIRCLE) || pathcounter==1 ) {
	if (pathcounter>=PATHMAX-1)
		freeup100points();
	if (pathx[pathcounter-1]!=mapx || pathy[pathcounter-1]!=mapy) {
		double deltapath, bearing;
		GeoRangeAndBearing(c.lat, c.lon, curlat,curlon, &deltapath, &bearing) ;
		//fprintf(stdout,"%f;;;%f:: %f:%f :: %f:%f\n",pathdist, deltapath, curlat,curlon,c.lat,c.lon);	
		pathx[pathcounter]=mapx;
		pathy[pathcounter]=mapy;
		if (curlon==0 && curlat==0)
			deltapath=0;
		curlat=c.lat;
		curlon=c.lon;
		pathdist+=deltapath;
		
		pathcounter++;
		//fprintf(stdout,"pathcounter=%d\n", pathcounter);
	}
	
}
}

void splashscreen() {
	Image * splashscreen=ldImage("system/splashscreen.png");
	blitAlphaImageToScreen(0,0,PSP_WIDTH,PSP_HEIGHT,splashscreen,0,0);
	flipScreen();
	sceKernelDelayThread(2000000);
	if (splashscreen!=NULL)
		freeImage(splashscreen);
}


void readConfig() {
	FILE * fp=fopn("system/config.txt", "r");
	if (fp==NULL)
		return;
	char line[128];
	pspTime rtime;
	sceRtcGetCurrentClockLocalTime(&rtime);
	int hhr = rtime.hour;
	int lochr = hhr;
	sceRtcGetCurrentClock(&rtime,0);
	int utchour = rtime.hour;
	int utchr = utchour;
	timezone = lochr - utchr;

	while(fgets(line,128,fp) != NULL) {
		if (line[0]=='#')
			continue;
		if (strncmp(line,"BAUD=",5)==0) {
			baud=atoi(&line[5]);
		}
		if (strncmp(line,"FAKEFEED=",9)==0) {
			fakefeed=atoi(&line[9]);
		}
		if (strncmp(line,"INITLOCATION=",9)==0) {
                        initLocation=atol(&line[13]);
                }
		if (strncmp(line,"DMS=",4)==0) {
			dms=atoi(&line[4]);
		}
		if (strncmp(line,"CHECKSUM=",9)==0) {
			checksum=atoi(&line[9]);
		}
		if (strncmp(line,"SPEEDFIX=",9)==0) {
			speedfix=atof(&line[9]);
		}
		if (strncmp(line,"SPEEDLIMIT=",11)==0) {
			speedlimit=atof(&line[11]);
		}
		if (strncmp(line,"NIGHTMODE=",10)==0) {
			nightmode=atoi(&line[10]);
		}
		if (strncmp(line,"ALTFIX=",7)==0) {
			altfix=atof(&line[7]);
		}
		if (strncmp(line,"TIMEZONE=",9)==0) {
			timezone=atoi(&line[9]);
		}
		if (strncmp(line,"WARNINGDISTANCE=",16)==0) {
			warn_dist=atoi(&line[16]);
		}
		if (strncmp(line,"SPEEDFACTOR=",12)==0) {
			speedfactor=atof(&line[12]);
		}
		if (strncmp(line,"TURNSPEED=",10)==0) {
			turnspeed=atoi(&line[10]);
		}
		if (strncmp(line,"STARTUPMAP=",11)==0) {
			strcpy(startupmap,&line[11]);
				startupmap[strlen(startupmap)-1]='\0';
		}

		if (strncmp(line,"LOADWIFI=",9)==0) {
			loadwifi=atoi(&line[9]);
		}
		if (strncmp(line,"STARTUPFREQUENCY=",17)==0) {
			startupfrequency=atoi(&line[17]);
		}
		if (strncmp(line,"SATINFOFREQUENCY=",17)==0) {
			satinfofrequency=atoi(&line[17]);
		}
		if (strncmp(line,"STARTUPSCREENMODE=",18)==0) {
			rotatemap=atoi(&line[18]);
		}
		if (strncmp(line,"CACHEMAPINDEX=",14)==0) {
			cachemapindex=atoi(&line[14]);
		}
		if (strncmp(line,"DEBUGLOG=",9)==0) {
                        debug_logging=atoi(&line[9]);
                }
		if (strncmp(line,"CACHEDELAY=",11)==0) {
                        cachedelay=atoi(&line[11]);
                }
	}

	fclose(fp);
}

//void myprint(char * str) {
void myprint(char *fmt,...) {
va_list args;
	//fprintf(stdout,fmt);
	//fprintf(stdout,"\n");
	memset(messages[messagecount],0,60);
	//strcpy(messages[messagecount++], str); 
	 va_start(args, fmt);
	vsprintf(messages[messagecount++], fmt, args); 
	if (messagecount>14) {
		int i;
		for (i=0; i<15; i++)
			strcpy(messages[i], messages[i+1]);
		messagecount--;
	}
	 va_end(args);
}


void safe_map_prefs (int x,int y, int zoom) {
	char filestr[128];
	sprintf(filestr,"%s/map_pref.txt",zipfile);
	FILE * fp=fopn(filestr,"w");
	if (fp!=NULL) {
		fprintf(fp,"%d %d %d\n",x,y,zoom);
		//fprintf(stdout,"%d %d %d\n",x,y,zoom);
	fclose(fp);
	}
}

int load_mapp_prefs () {
	char filestr[128];
	int z,rd;
        char xstr[30], ystr[30];
	sprintf(filestr,"%s/map_pref.txt",zipfile);
	FILE * fp=fopn(filestr,"r");
	if (fp!=NULL) {
                rd=fscanf(fp,"%s %s %d",  xstr, ystr , &z);
                if (rd<3) 
			return -1;

		mapx=atoi(xstr);
		mapy=atoi(ystr);
		zoom=z;

	fclose(fp);
	return 1;
	}
	return -1;
}

int calc_mapsize(int sz) {
	int i=sz;
	int total=0;
	while ( i>1) {
		total+=i*i;
		i/=2;
	}
	return total;
}

int wget(SceSize argc, void* argv)
{ 
	killwifi=0;
	int tilenumber= calc_mapsize(mapsize);
	ms_write_log("IN wget\n");
	myprint("##### PREPAIRING TO GET %d TILES", tilenumber);
    	myprint("##### CONNECTING.... ");

 FILE * fp;
   // init wlan
   int err = pspSdkInetInit();
   if (err != 0) {
      myprint("!!!InetInit failed: %d", err);
      fprintf(stdout,"!!!InetInit failed: %d\n", err);
      //return -1;
   }


   // print available connections
   myprint("##### AVAILABLE CONNECTIONS:\n");
   int i;
   for (i = 1; i < 100; i++) // skip the 0th connection
   {
      if (sceUtilityCheckNetParam(i) != 0) break;  // no more
      char name[60];
      sceUtilityGetNetParam(i, 0, (netData*) name);
      myprint("%i: %s\n", i, name);
	if (killwifi) return -1;
   }

   int k=0;
   int j=1;
   
   // WLAN is initialized when PSP IP address is available
	myprint("##### GETTING IP ADDRESS...");
   char pspIPAddr[32];
   for (j=1;j<=i;j++) {
   	myprint("TRYING CONNECTION # %d....",j);
   	err = sceNetApctlConnect(j);
   	if (err != 0) {
      		myprint("sceNetApctlConnect failed: %d", err);
      		return -1;
   	}

   k=0;
   while (k<20) {
      if (sceNetApctlGetInfo(8, pspIPAddr) == 0) break;
      myprint("attempt %d out of 20",k++);
	if (killwifi) return -1;
      sceKernelDelayThread(1000 * 1000);  // wait a second
   }
  if (k<20)
	break;
  }

	if (k==20) {
      		myprint("Failed to get IP address: %d", err);
      		return -1;
	}
   myprint("##### PSP IP ADDRESS: %s", pspIPAddr);

   // start DNS resolver
   err = sceNetResolverCreate(&resolverId, resolverBuffer, sizeof(resolverBuffer)); 
 if (err != 0) {
      myprint("sceNetResolverCreate failed: %i", err);
      return -1;
   }

   // resolve host
   myprint("##### RESOLVING HOST...\n");
   const char *host = "mt1.google.com";
   int port = 80;
   struct sockaddr_in addrTo;
   addrTo.sin_family = AF_INET;
   addrTo.sin_port = htons(port);
   //err = sceNetInetInetAton(host, &addrTo.sin_addr);
   //err = sceNetInetInetAton(host, &addrTo.sin_addr);
   if (err == 0) {
      err = sceNetResolverStartNtoA(resolverId, host, &addrTo.sin_addr, 2, 3);
      if (err != 0) {
         myprint("RESOLUTION FAILED...");
         return -1;
      }
   }
    	Coord tileco=getTileCoord(latitude,longitude,basezoom);
	int ms_original = mapsize;
   	mkdir(dirname, S_IREAD| S_IWRITE);

	int tilex=( (int)(tileco.lon/mapsize)) *mapsize;
	int tiley=( (int)(tileco.lat/mapsize)) *mapsize;

	char curdir[200];
	sprintf(curdir,"%s/coords.txt",dirname);
	FILE * cf=fopn(curdir,"w");
	if (cf!=NULL) {
		fprintf(cf,"%d %d %d\n", tilex, tiley, basezoom);
		fclose(cf);
	}
        int counter=0;;

	while(mapsize > 1) {	
		if (killwifi)
			return -1;
		int mapzoom= ms_original/mapsize;
		sprintf(curdir,"%s/%dx",dirname,mapzoom);
		mkdir (curdir, S_IREAD| S_IWRITE);
		int yc=0;
		while (yc < mapsize) {
			sprintf(curdir,"%s/%dx/%03d",dirname,mapzoom,yc);	
			mkdir (curdir, S_IREAD| S_IWRITE);
			int xc=0;
			
			while (xc < mapsize) {	

   // create socket (in blocking mode)
   myprint("##### CREATING SOCKET...");
   int sock = socket(AF_INET, SOCK_STREAM, 0);
   if (sock < 0) {
      myprint("SOCKET FAILED");
      return -1;
   }

   // connect (this may block some time)
   myprint("#### CONNECTING...\n");
   err = connect(sock, (struct sockaddr*) &addrTo, sizeof(addrTo));
   if (err != 0) {
      myprint("CONNECT FAILED");
      return -1;
   }
 // send HTTP request
   myprint("LOADING %d OUT OF %d", counter++,tilenumber);
   char request[512];
   sprintf(request,"GET /mt?v=w2.71&x=%d&y=%d&zoom=%d HTTP/1.0\r\nhost: mt1.google.com\r\n\r\n",tilex+xc,tiley+yc,basezoom);
   err = send(sock, request, strlen(request), 0);
   if (err < 0) {
      myprint("send failed");
      return -1;
   }

   // read all
   int capacity = 256;
   int len = 0;
   u8* buffer = (u8*) malloc(capacity);
   while (1) {
      //printf(".");

      // read data
      int count = recv(sock, (u8*) &buffer[len], capacity - len, 0);

      // in blocking mode it has to return something, otherwise it is closed
      // (which is the default for HTTP/1.0 connections)
      if (count == 0) break;

      if (count < 0) {
         myprint("READ ERROR");
         break;
      }

      // adjust buffer, if needed
      len += count;
      if (len + 256 > capacity) {
         capacity *= 2;
         buffer = (u8*) realloc(buffer, capacity);
         if (!buffer) break;
      }
   }
  // now "len" bytes data are in buffer, add a 0 at end for printing and search for header end
   if (buffer) {
      buffer[len] = 0;
        int j;

        for (j=4; j<len ; j++) {
                if (buffer[j]=='\n' && buffer[j-1]=='\r' &&buffer[j-2]=='\n' &&buffer[j-3]=='\r')
                        break;

        }
        j++;
	sprintf(curdir,"%s/%dx/%03d/%dx%03d%03d.png",dirname,mapzoom,yc,mapzoom,yc,xc);	
         fp=fopn(curdir, "w");
        if (fp!=NULL) {
                for (i=j; i<len ; i++)
                        fputc(buffer[i],fp);
                fclose(fp);
        }
         //printf("\n\n%s", page);
         //myprint("DONE!");
      free(buffer);
   }

        close(sock);
	xc++;
}
	yc++;
}
	tilex/=2;
	tiley/=2;
	basezoom+=1;
	mapsize/=2;
}
   ///////////// PSP specific part ///////////////

   // term, TODO: this doesn't work
   sceNetApctlDisconnect();
   pspSdkInetTerm();
  myprint("DOWNLOAD COMPLETED!!!");
  sceKernelExitDeleteThread(0);

  return 0;
}







void copy_pad(char * dest, char * src, int len) {
	//center the message...
	int l=0, half=0;
	int slen=strlen(src);
	if (slen>len) {
		src[len]=0;
		slen=len;
	}
	l=len - slen;
	half=(int)l/2;
	memset(dest,' ', half);
	strcpy(&dest[half], src);
	memset(&dest[half+slen],' ', len-half-slen);
	dest[len]=0;
}

void display_alert(char* line1, char* line2) {
 	char l[49];
        memset(l,0,sizeof l);
	//printf ("[%s][%s]\n", line1, line2);
	blitAlphaImageToScreen(0,0,480,68,messageplate,0,204);

	copy_pad(l,line1,48);
        draw_big_string (l,10,212);

	int i;
        memset(l,0,sizeof l);
	for (i=45; i>0; i--) {
		if(line2[i]==' ' || line2[i]==';') {
			line2[i]='\0';
			break;
		}
		if(line2[i]==0)
			break;
	}
	copy_pad(l,line2,48);
        draw_big_string (l,10,230);
	if (i<10) 
		return;
	char *line3 = &line2[i+1];
        memset(l,0,sizeof l);
	copy_pad(l,line3,48);
        draw_big_string (l,10,248);
	return;
}


void display_message_no_block(char* l1, char* l2, char* l3) {
	char line1[64];
	char line2[64];
	char line3[64];
	strcpy(line1,l1);
	strcpy(line2,l2);
	strcpy(line3,l3);
	translate(line1);
	translate(line2);
	translate(line3);
	int len=30;
	Image * menuwindow=ldImage("system/menuwindow.png");

	if (len<=(signed int)strlen(line1)) len=strlen(line1)+4;
	if (len<=(signed int)strlen(line2)) len=strlen(line2)+4;
	if (len<=(signed int)strlen(line3)) len=strlen(line3)+4;

	char * messageline = (char*) malloc(len*sizeof(char));

	int x= PSP_WIDTH/2 - len*5;

	if (menuwindow!=NULL) {
		blitAlphaImageToScreen(0,0,100,128,menuwindow,x-10,70);
		blitAlphaImageToScreen(545-len*10,0,len*10-90,128,menuwindow,x+90,70);
	} else
		fillScreenRect(0x000000cc,x-10,700,len*10+20,128);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line1))/2],line1, strlen(line1));
	draw_big_string (messageline,x,110);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line2))/2],line2, strlen(line2));
	draw_big_string (messageline,x,130);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line3))/2],line3, strlen(line3));
	draw_big_string (messageline,x,150);


	free (messageline);
	if (menuwindow!=NULL)
		freeImage(menuwindow);

}



void display_message(char* l1, char* l2, char* l3, int timeout) {
	char line1[64];
	char line2[64];
	char line3[64];
	strcpy(line1,l1);
	strcpy(line2,l2);
	strcpy(line3,l3);
	translate(line1);
	translate(line2);
	translate(line3);
	int len=30, counter=0;
	Color * bg=NULL;
	if (timeout>0) {
		bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
		memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);
	}

	Image * menuwindow=ldImage("system/menuwindow.png");

	if (len<=(signed int)strlen(line1)) len=strlen(line1)+4;
	if (len<=(signed int)strlen(line2)) len=strlen(line2)+4;
	if (len<=(signed int)strlen(line3)) len=strlen(line3)+4;

	char * messageline = (char*) malloc(len*sizeof(char));

	int x= PSP_WIDTH/2 - len*5;

	if (menuwindow!=NULL) {
		blitAlphaImageToScreen(0,0,100,128,menuwindow,x-10,70);
		blitAlphaImageToScreen(545-len*10,0,len*10-90,128,menuwindow,x+90,70);
	} else
		fillScreenRect(0x000000cc,x-10,700,len*10+20,128);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line1))/2],line1, strlen(line1));
	draw_big_string (messageline,x,110);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line2))/2],line2, strlen(line2));
	draw_big_string (messageline,x,130);

	memset(messageline,' ', sizeof(char)*len-1);
	messageline[len-1]=0;
	strncpy(&messageline[(len -strlen(line3))/2],line3, strlen(line3));
	draw_big_string (messageline,x,150);

	flipScreen(); 
	if (timeout>0)
        	sceKernelDelayThread(500000);
	cpad.Buttons=0;         // MIB.42_2 to clear last state
        while (!(cpad.Buttons & PSP_CTRL_CROSS) && counter < timeout && !(cpad.Buttons & PSP_CTRL_RIGHT) ) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		counter++;
		sceKernelDelayThread(1000);
	}
	if (timeout>0 && bg!=NULL) {
		memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		memcpy( getVramDisplayBuffer(),bg, FRAMEBUFFER_SIZE);
		flipScreen();
		free(bg);
	}
        sceKernelDelayThread(1);

	free (messageline);
	if (menuwindow!=NULL)
		freeImage(menuwindow);

}




void deleteChar(char * str, int pos) {
	if (pos>=(signed int)strlen(str))
		return;
	int i;
	for ( i=pos; i<(signed int)strlen(str); i++)
		str[i]=str[i+1];
}

void insertChar(char * str, int pos, char ch) {
	int len=strlen(str);
	if (pos>len)
		return;
	str[len+1]=0;
	int i;
	for (i=len; i>=pos; i--)
		str[i+1]=str[i];
	str[pos]=ch;	
}

void toUpperCase(char * str) {
	char *ptr=str;
	for(ptr=str;*ptr;ptr++)
   {
       if (*ptr >= 97 && *ptr <= 122) /* a-z */
       {
           *ptr-=32;
       }
   }

}


void initLatLon() {
	static int c = 256;
	int d;
 	for ( d = 17; d >= -2; --d) { 
		 int dd=d;
                 if (dd<0) dd=dd*(-1)+17;
                 pixelsPerLonDegree[dd] = c / 360;
                 pixelsPerLonRadian[dd] = c / bc;
                 bitmapOrigo[dd] = c/2;
                 numTiles[dd] = c / 256;
                 c *= 2;
	}
}




Coord getLatLong(int x, int y, int zoom) {
      double lon      = -180; // x
      double lonWidth = 360; // width 360
      int zooom=zoom+2;
      double lat       = -1;
      double latHeight = 2;

      int tilesAtThisZoom = 1 << (19 - zooom);
      lonWidth  = 360.0 / tilesAtThisZoom;
      lon       = -180 + (x * lonWidth);
      latHeight = -2.0 / tilesAtThisZoom;
      lat       = 1 + (y * latHeight);

      // convert lat and latHeight to degrees in a transverse mercator projection
      // note that in fact the coordinates go from about -85 to +85 not -90 to 90!
      latHeight += lat;
      latHeight = (2 * atan(exp(PI * latHeight))) - (PI / 2);
      latHeight *= (180 / PI);

      lat = (2 * atan(exp(PI * lat))) - (PI / 2);
      lat *= (180 / PI);

      latHeight -= lat;

      if (lonWidth < 0) {
         lon      = lon + lonWidth;
         lonWidth = -lonWidth;
      }

      if (latHeight < 0) {
         lat       = lat + latHeight;
         latHeight = -latHeight;
      }

	Coord c;
	c.lat=lat;
	c.lon=lon;
	c.lonWidth=lonWidth;
	c.latHeight=latHeight;
      return c;
}


//puts x value in Coord.lon and y value in Coord.lat
Coord getTileCoord(double lat, double lon, int zoomLl ) {
	int x,y;
	int zoomLevel=zoomLl;
	if (zoomLevel<0) zoomLevel=zoomLevel*(-1)+17;
	 x= (int)(bitmapOrigo[zoomLevel] + lon * pixelsPerLonDegree[zoomLevel]);
	 x/=256;
                double e = sin(lat * Wa);

                if (e > 0.9999) {
                        e = 0.9999;
                }

                if (e < -0.9999) {
                        e = -0.9999;
                }

                y = (int)(bitmapOrigo[zoomLevel] + 0.5
                                * log((1 + e) / (1 - e)) * -1
                                * (pixelsPerLonRadian[zoomLevel]));
		y/=256;

		Coord cc;
		cc.lon=x;
		cc.lat=y;
		return cc;

} 

//puts x value in Coord.lon and y value in Coord.lat
Coord getXY(double lat, double lon, int zoom) {
	Coord c;
	long x,y;
	int zoomLevel=zoom;
        if (zoomLevel<0) zoomLevel=zoomLevel*(-1)+17;

	 x= (long)(bitmapOrigo[zoomLevel] + lon * pixelsPerLonDegree[zoomLevel]);
	 x/=256;
                double e = sin(lat * Wa);

                if (e > 0.9999) {
                        e = 0.9999;
                }

                if (e < -0.9999) {
                        e = -0.9999;
                }

                y = (long)(bitmapOrigo[zoomLevel] + 0.5
                                * log((1 + e) / (1 - e)) * -1
                                * (pixelsPerLonRadian[zoomLevel]));
		y/=256;
		c=getLatLong(x,y,basezoom);

		c.lon=(x-ftx)*TILE_SIZE+(lon-c.lon)*TILE_SIZE/c.lonWidth;
		c.lat=(y-fty)*TILE_SIZE+(c.lat-lat)*TILE_SIZE/c.latHeight+TILE_SIZE;
		return c;

}

void readAttractionsListings() {
	optcount=0;
  	DIR *dp;
  	struct dirent *dir;
	char path[128];
        sprintf(path,"%s/%s",currentpath,zipfile);
#ifndef GENERIC
	if ( (dp = opendir(path)) == NULL ) {
#else
	if ( (dp = opendir(zipfile)) == NULL ) {
#endif
    		//printf("Can't open directory: %s\n", zipfile);
    		return;
  	}
  	while ((dir = readdir(dp)) != NULL) {
        	if (dir->d_name[0]!='_') continue;
    		//fprintf(stdout,"%s\n", dir->d_name);
    		strcpy(options[optcount++],dir->d_name);
  	}
  	closedir(dp);


#ifndef GENERIC
        sprintf(path,"ms0:/PSP/COMMON");
#else
        sprintf(path,"/PSP/COMMON");
#endif
	if ( (dp = opendir(path)) == NULL ) {
    		//printf("Can't open directory: %s\n", path);
    		return;
  	}
  	while ((dir = readdir(dp)) != NULL) {
        	if (dir->d_name[0]!='_') continue;
    		//fprintf(stdout,"%s\n", dir->d_name);
    		strcpy(options[optcount++],dir->d_name);
  	}
  	closedir(dp);


}

void readMapListings(void) {
  DIR *dp;
  struct dirent *dir;
 optcount=0;
#ifndef GENERIC
 char path[128];
  sprintf(path,"%s/maps",currentpath);
  if ( (dp = opendir(path)) == NULL ) {
#else
  if ( (dp = opendir("./maps")) == NULL ) {
#endif
	display_message("CRITICAL ERROR","","NO MAPS DIRECTORY FOUND!",0);
	display_message("CRITICAL ERROR","","NO MAPS DIRECTORY FOUND!",0);
	display_message("CRITICAL ERROR","","NO MAPS DIRECTORY FOUND!",0);
	display_message("CRITICAL ERROR","","NO MAPS DIRECTORY FOUND!",0);
	display_message("CRITICAL ERROR","","NO MAPS DIRECTORY FOUND!",1000);
//	fprintf(stderr, "Can't open directory: ");
	if (gpsout!=NULL) {
		fclose(gpsout);
		gpsout=NULL;
	}
	unload_group(4096,zipfile,datatype);
        imglist_garbagecollect();
	sceKernelDelayThread(500000);
	if (datatype==1)
		gpsfsClose();
	if (attr_flag==1) 
              turn_off_attractions();
	cleanup_output();
        sceKernelExitGame();
	exit(1);

  }
  while ((dir = readdir(dp)) != NULL) {
	if (dir->d_name[0]!='_') continue;
    //fprintf(stdout,"%s\n", dir->d_name);
    strcpy(options[optcount],dir->d_name);
    optcount++;
  }
  if (loadwifi)
 	strcpy(options[optcount++],"===_WIFI_MAP_UPLOAD_===");
  closedir(dp);
}

void beep(){		// MIB.42_7
	char filepath[64];
	sprintf(filepath,"%s/system/sounds/beep.mp3", currentpath);
	MP3_PlaySnipet(filepath);
};

void play_alert(int which){		// MIB.42_7
	if (MP3_playing==1 || which==0) return;
	char filepath1[256];
	sprintf(filepath1,"%s/%s/message%03d.mp3", currentpath,zipfile,which);
	if (my_access1(filepath1, F_OK) != 0)
		sprintf(filepath1,"%s/system/sounds/message%03d.mp3", currentpath,which);
	if (my_access1(filepath1, F_OK) == 0) {
		MP3_Play(filepath1,0);
	}

};

void playfile(char * filename) {
	char filepath[64];
	sprintf(filepath,"%s/system/sounds/%s", currentpath,filename);
	MP3_PlaySnipet(filepath);
}

void drawHiliteBar(Image * hilite,int x,int y, int width) {
	int i;
	if (hilite==NULL)
		return;
	for ( i=0; i<width; i++)
		blitAlphaImageToScreen(0,0,8,8,hilite,x+i*8,y);
}


void pad(char * str) {
	int i;
	for ( i=0; i<(signed int)strlen(str); i++) {
		if (str[i]==' ' || str[i]=='/' || str[i]=='\\' || str[i]=='?' || str[i]=='<' || str[i]=='>')
			str[i]='_';

	}
}

int check_fields(char * name, double lat, double lon, int bz, int sz) {
	pad (name);
	if (lat==0.0 || lon==0.0)
		return -1;
	if (bz<0 || bz>14)
		return -1;
	if (sz!=4 && sz!=8 && sz!=16 && sz!=32 && sz!=64 && sz!=128 && sz!=256 && sz!=512) 
		return -1;
	return 1;

}

int search_poi_menu(char * filename) {
	char label1[64]="::: SEARCH POI FORM :::"; translate(label1);
	char label2[64]="ENTER SEARCH WORD OR LEAVE BLANK FOR PROXIMITY SEARCH"; translate(label2);
	int current=0;
	char headers[1][16] = { "SEARCH FOR:"}; translate(headers[0]);
	char notes[1][64] = { "PRESS START TO SEARCH......" }; translate(notes[0]);
	int lens[1]= { 30};
	int size=0;
	char values[1][64];
    	Coord co=getGPS(mapx, mapy);
	memset(values[0],0,64);
	int edit_pos=0;
	char error[32];
	strcpy( error,"");
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	Image * menuwindow=ldImage("system/menuwindow.png");
	Image * hilite=ldImage("system/hilite.png");

	 Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
        memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	danzeff_load(); 
	if (!(danzeff_isinitialized())) { return 0; } 
	danzeff_moveTo(300,96);
	int blinkcounter=0;
        while (1) {
		sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		} else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-26*4, 34);
               	draw_string( label2,32, 52);
		int i,j;
		for ( i=0; i<1; i++) {
               		draw_string_no_und( headers[i], 20, 73+15*i);
			if (i==current) {
				for ( j=0; j<(signed int)strlen(values[i])+2; j++) {
					drawHiliteBar(hilite,102+j*8, 69+15*i,1); 
					drawHiliteBar(hilite,102+j*8, 77+15*i,1); 
				}
				if (blinkcounter++>10) 
               				draw_string( "-", 110+edit_pos*8, 79+15*i);
				if (blinkcounter++>18)
					blinkcounter=0;
			}
               		draw_string( values[i], 110, 73+15*i);
		}
               	draw_string( error, 35,200 );
	
               	draw_string( notes[current], 15,248 );
    		danzeff_render(); 
		char key= danzeff_readInput(cpad);

		if (key==DANZEFF_START) {
				beep();
				break;

		}

		switch (key) 
               { 
          case 0: 
          break; 
         case 9: if (current>0) {
			beep();
			current--;
			edit_pos=0;
		}
		strcpy( error,"");
		break; 
         case '\n': if (current<4) {
			current++; 
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break;
         case DANZEFF_LEFT: if (edit_pos>0) edit_pos--;
		strcpy( error,"");
		break; 
         case DANZEFF_RIGHT: if (edit_pos<lens[current]) edit_pos++;
		strcpy( error,"");
		beep();
		break;
         case DANZEFF_SELECT: 
		beep();
		if (menuwindow!=NULL)
			freeImage(menuwindow);
		 if (bg!=NULL)
                	free(bg);
		danzeff_free();
		return 0;
         case DANZEFF_START: beep(); break; 
	case 8: //delete
		beep();
		strcpy( error,"");
		deleteChar(values[current],edit_pos);
		break;
	case 7: //backspace		// MIB.42_4
		beep();
		strcpy( error,"");
		if(edit_pos>0)
		{
			--edit_pos;
			deleteChar(values[current],edit_pos);
		}
		break;
         default: 
		beep();
		strcpy( error,"");
		if ((signed int)strlen(values[current])<lens[current]) {
			insertChar(values[current],edit_pos,key);
			edit_pos++;
		}
		toUpperCase(values[current]);
             //fprintf(stdout,"You have input the key %c\n",key); 
             break; 
       	}
	flipScreen();

	}
	danzeff_free();
	strcpy(label1, "::: SEARCHING :::"); translate (label1);
	strcpy(label2, "PLEASE WAIT WHILE SEARCH IS IN PROGRESS"); translate (label2);
	if (bg!=NULL)
                       memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
	if (menuwindow!=NULL) {
		blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
		blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
	}else
		fillScreenRect(0x000000cc,12,28,455,232);
        draw_string( label1, PSP_WIDTH/2-26*4, 34);
        draw_string( label2, PSP_WIDTH/2-26*4-50, 112);

         flipScreen();
	turn_off_attractions();
	 int attr_counter=load_attractions(filename, zipfile, datatype,  mapx,  mapy, zoom, values[0]);
	int k;
	for (k=0;k<=get_image_count(); k++) {
	//fprintf(stdout,"%d---->[%s]\n",get_image_count(),attr_ifile[k]);
	if (strlen(attr_ifile[k])==0)
                       attraction[k] = ldImage("system/icons/attraction.png");
              else {
                               char filename1[128];
                               sprintf(filename1,"%s/%s", zipfile,attr_ifile[k]);
				if (my_access(filename1, F_OK) != 0)
                               		sprintf(filename1,"system/icons/%s", attr_ifile[k]);
				if (my_access(filename1, F_OK) != 0)
                               		sprintf(filename1,"system/icons/attraction.png");
                               attraction[k]=ldImage(filename1);
               }
	}
	if (attr_counter==0) {
		strcpy(label1, "NO RECORDS FOUND"); translate (label1);
        	draw_string(label1, PSP_WIDTH/2-26*4, 120);
		turn_off_attractions();
         	flipScreen();
                sceKernelDelayThread(1500000);
		if (menuwindow!=NULL)
			freeImage(menuwindow);
		if (hilite!=NULL)
			freeImage(hilite);
	 	if (bg!=NULL)
               		free(bg);
		return 0;
	}
	qsort( attractions, attr_counter,sizeof(attractions[0]),attr_cmp);
	if (attr_counter>MAXLISTSIZE)
		size=MAXLISTSIZE;
	else
		size=attr_counter;

	int cur=0;
	int timer=0;
	int topline=0;
	strcpy(label1, "::: POI SEARCH RESULTS"); translate (label1);

	while (!(cpad.Buttons & PSP_CTRL_CROSS)) {
                sceCtrlPeekBufferPositive(&cpad, 1);
                sceKernelDelayThread(1);


                if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>7/(333/Clock)) {
                        timer=0;
                        break;
                }
                if (cpad.Buttons & PSP_CTRL_SELECT) {

			turn_off_attractions();
			if (menuwindow!=NULL)
				freeImage(menuwindow);
	 		if (bg!=NULL)
               			free(bg);
                        return -100000;
                }

                if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>2/(333/Clock)) {
                        if (cur<size-1) {
                                cur++;
                                if (cur-topline>12)
                                        topline++;
                                beep();
                        }       
                        timer=0;
                }

                if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>2/(333/Clock)) {
                        timer=0;
                        if (cur>0) {
                                cur--;
                                if (cur<topline && topline>0)
                                        topline--;
                                beep();
                        }
                }


                timer++;
                if (timer>100) timer=11;
                if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
                if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
                } else
                        fillScreenRect(0x000000cc,12,28,455,232);
		sprintf(values[0],"%s [%d] :::",label1,size);
        	draw_string( values[0], PSP_WIDTH/2-26*4, 34);
		drawHiliteBar(hilite,20,(cur-topline)*15+57,55 ); 
		drawHiliteBar(hilite,20,(cur-topline)*15+65,55 ); 


		double dist=0;
		double bearing=0;
		int i;
		for ( i=0; i<13 && i<size; i++) {
			Coord attrco=getGPS(attractions[i+topline]->x,attractions[i+topline]->y);
			GeoRangeAndBearing(co.lat, co.lon, attrco.lat,attrco.lon, &dist, &bearing) ;

			 
			if (speedfix>1.8) //kilometers
                        	sprintf(filename,"%-38s %7.2f KM %-2s",attractions[i+topline]->name,dist/1000,heading[((int)bearing+22)%360/45]);
			else	
                        	sprintf(filename,"%-38s %7.2f MI %-2s",attractions[i+topline]->name,dist/1609.344,heading[((int)bearing+22)%360/45]);
                        toUpperCase(filename);
                        draw_string( filename, 30, i*15+61);

                }


                flipScreen();
                sceKernelDelayThread(5);


        }

	mapx=attractions[cur]->x;
	mapy=attractions[cur]->y;
	attr_flag=1;

	if (menuwindow!=NULL)
		freeImage(menuwindow);
	 if (bg!=NULL)
               	free(bg);
	 if (hilite!=NULL)
               	freeImage(hilite);

	return 0;
}


int add_poi_menu() {
	char label1[64]="::: ADD POI FORM :::"; translate(label1);
	char label2[64]="EDIT THE FIELDS BELOW AND PRESS [START] BUTTON"; translate(label2);
	int current=0;
	char headers[4][16] = { "POI NAME:" , "DESC:", "LATITUDE:", "LONGITUDE:"  };
	translate(headers[0]);
	translate(headers[1]);
	translate(headers[2]);
	translate(headers[3]);
	char notes[4][64] = { "NOTE: SOME CHARACTERS ARE NOT SUPPORTED" ,"NOTE: SOME CHARACTERS ARE NOT SUPPORTED" , "NOTE: MUST BE IN DECIMAL FORMAT", "NOTE: MUST BE IN DECIMAL FORMAT" };
	translate(notes[0]);
	translate(notes[1]);
	translate(notes[2]);
	translate(notes[3]);
	int lens[4]= { 37,43,18,18};
	char values[5][64];
    	Coord co=getGPS(mapx, mapy);
	
// MIB.42_4
	double plat;
	double plon;
		plat=co.lat;
		plon=co.lon;
		char NS='N';
		char EW='E';
		if(dms!=0)
		{
			if (plat<0) {
				plat*=-1;
				NS='S';
			} else if (plat==0)
				NS=' ';
			if (plon<0) {
				plon*=-1;
				EW='W';
			}else if (plon==0)
				EW=' ';
		}

		switch(dms)
		{
			case 1 :
				sprintf(values[0],"MY POI %c%1.0f\260%02.6f' X %c%1.0f\260%02.6f'",NS, floor(plat), 60*(plat-floor(plat)), EW, floor(plon), 60*(plon-floor(plon)));
				sprintf(values[2],"%c%1.0f\260%02.6f'",NS, floor(plat), 60*(plat-floor(plat)));
				sprintf(values[3],"%c%1.0f\260%02.6f'",EW, floor(plon), 60*(plon-floor(plon)));
			break;
			case 2 :                                // \260=deg \042=0x22=" \047=0x27='
			{
			double plat_min,plat_sec,plon_min,plon_sec;
				plat_min=60*(plat-floor(plat));
				plat_sec=60*(plat_min-floor(plat_min));
				plon_min=60*(plon-floor(plon));
				plon_sec=60*(plon_min-floor(plon_min));
				sprintf(values[0],"MY POI %c%1.0f\260%02.0f\047%02.4f\042 X %c%1.0f\260%02.0f\047%02.4f\042",NS, floor(plat), floor(plat_min), plat_sec, EW, floor(plon), floor(plon_min), plon_sec);
				sprintf(values[2],"%c%1.0f\260%02.0f\047%02.4f\042",NS, floor(plat), floor(plat_min), plat_sec);
				sprintf(values[3],"%c%1.0f\260%02.0f\047%02.4f\042",EW, floor(plon), floor(plon_min), plon_sec);
			}
			break;
			default :
				sprintf(values[0],"MY POI %10.6f X %10.6f",co.lat, co.lon);
				sprintf(values[2],"%f",co.lat);
				sprintf(values[3],"%f",co.lon);
			break;
		}
	sprintf(values[1]," ");


	int edit_pos=0;
	char error[32];
	strcpy( error,"");
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	Image * menuwindow=ldImage("system/menuwindow.png");
	Image * hilite=ldImage("system/hilite.png");

	 Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
        memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	danzeff_load(); 
	if (!(danzeff_isinitialized())) { return 0; } 
	danzeff_moveTo(300,96);
	int blinkcounter=0;
        while (1) {
		sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		} else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-26*4, 34);
               	draw_string( label2, 58, 48);
		int i,j;
		for ( i=0; i<4; i++) {
               		draw_string( headers[i], 20, 73+15*i);
			if (i==current) {
				for (j=0; j<(signed int)strlen(values[i])+2; j++) {
					drawHiliteBar(hilite,102+j*8, 69+15*i,1 ); 
					drawHiliteBar(hilite,102+j*8, 77+15*i,1 ); 
				}
				if (blinkcounter++>10) 
               				draw_string( "-", 110+edit_pos*8, 79+15*i);
				if (blinkcounter++>18)
					blinkcounter=0;
			}
               		draw_string( values[i], 110, 73+15*i);
		}
               	draw_string( error, 35,200 );
	
               	draw_string( notes[current], 15,248 );
    		danzeff_render(); 
		char key= danzeff_readInput(cpad);

		if (key==DANZEFF_START) {
			beep();
			if (check_fields(values[0], ConvertLocationStringToLocationDouble(values[2]), ConvertLocationStringToLocationDouble(values[3]), 2, 4)==1 && check_fields(values[1], ConvertLocationStringToLocationDouble(values[2]), ConvertLocationStringToLocationDouble(values[3]), 2, 4)==1) 
				break;

			else
				strcpy(error,"INCORRECT VALUES ENTERED!!!"); translate(error);


		}

		switch (key) 
               { 
          case 0: 
          	break; 
         case 9: if (current>0) {
			current--;
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break; 
         case '\n': if (current<4) {
			current++; 
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break;
         case DANZEFF_LEFT: if (edit_pos>0) edit_pos--;
		strcpy( error,"");
		beep();
		break; 
         case DANZEFF_RIGHT: if (edit_pos<lens[current]) edit_pos++;
		strcpy( error,"");
		beep();
		break;
         case DANZEFF_SELECT: 
		beep();
		if (menuwindow!=NULL)
			freeImage(menuwindow);
		if (hilite!=NULL)
			freeImage(hilite);
		 if (bg!=NULL)
                	free(bg);
		danzeff_free();
		return 0;
         case DANZEFF_START: break; 
	case 8: //delete
		beep();
		strcpy( error,"");
		deleteChar(values[current],edit_pos);
		break;
	case 7: //backspace		// MIB.42_4
		beep();
		strcpy( error,"");
		if(edit_pos>0)
		{
			--edit_pos;
			deleteChar(values[current],edit_pos);
		}
		break;

         default: 
		beep();
		strcpy( error,"");
		if ((signed int)strlen(values[current])<lens[current]) {
			insertChar(values[current],edit_pos,key);
			edit_pos++;
		}
		toUpperCase(values[current]);
             //fprintf(stdout,"You have input the key %c\n",key); 
             break; 
       }
		flipScreen();

	}

	danzeff_free();

	char filestr[128];
	sprintf(filestr,"%s/_MY_POIS",zipfile);
	FILE * pfp=fopn(filestr,"a");
	if (pfp!=NULL) {
		// Saving proper DMS format for the POIs  MIB.42_4 
		double plat;
		double plon;
		plat=ConvertLocationStringToLocationDouble(values[2]);
		plon=ConvertLocationStringToLocationDouble(values[3]);
		char NS='N';
		char EW='E';
		if(dms!=0)
		{
			if (plat<0) {
				plat*=-1;
				NS='S';
			} else if (plat==0)
				NS=' ';
			if (plon<0) {
				plon*=-1;
				EW='W';
			}else if (plon==0)
				EW=' ';
		}

		switch(dms)
		{
			case 1 :
				fprintf(pfp,"%c%1.0f\260%02.6f',%c%1.0f\260%02.6f',%s,%s,\n",  NS, floor(plat), 60*(plat-floor(plat)), EW, floor(plon), 60*(plon-floor(plon)), values[0], values[1]);
			break;
			case 2 :                                // \260=deg \042=0x22=" \047=0x27='
			{
			double plat_min,plat_sec,plon_min,plon_sec;

				plat_min=60*(plat-floor(plat));
				plat_sec=60*(plat_min-floor(plat_min));
				plon_min=60*(plon-floor(plon));
				plon_sec=60*(plon_min-floor(plon_min));
				fprintf(pfp,"%c%1.0f\260%02.0f\047%02.4f\042,%c%1.0f\260%02.0f\047%02.4f\042,%s,%s,\n",  NS, floor(plat), floor(plat_min), plat_sec, EW, floor(plon), floor(plon_min), plon_sec, values[0], values[1]);
			}
			break;
			default :
				fprintf(pfp,"%f,%f,%s,%s,\n", plat, plon, values[0], values[1]);
			break;
		}
//		fprintf(pfp,"%f,%f,%s,%s,\n",atof(values[2]), atof(values[3]), values[0], values[1]);
		fclose(pfp);
		turn_on_attractions();
	}

	if (menuwindow!=NULL)
		freeImage(menuwindow);
	if (hilite!=NULL)
		freeImage(hilite);
	 if (bg!=NULL)
               	free(bg);
	return 0;
}


int locate_address() {
	char label1[64]="::: ADDRESS LOCATOR FORM :::"; translate(label1);
	char label2[64]="POPULATE THE FIELDS BELOW AND PRESS [START] BUTTON"; translate(label2);
	char path[128];
	sprintf(path,"%s/geodata.dat",zipfile);
	FILE * test = fopn( path,"r");
	if (test==NULL)
		test = fopn( "geodata.dat","r");
	if (test==NULL) {
		display_message("ERROR!","GEODATA FILE","IS MISSING!",1000);
		return -1;

	} else
		fclose(test);
	int wait=21;
	int current=0;
	char headers[4][16] = { "STREET:" , "CITY:", "STATE:", "ZIPCODE:"  };
	translate(headers[0]);
	translate(headers[1]);
	translate(headers[2]);
	translate(headers[3]);
	char notes[4][64] = { "ENTER STREET NAME AND NUMBER" ,"ENTER NAME OF THE CITY" , "ENTER 2 LETTER STATE CODE", "ENTER 5 DIGIT ZIP CODE" };
	translate(notes[0]);
	translate(notes[1]);
	translate(notes[2]);
	translate(notes[3]);
	int lens[4]= { 37,20,3,6};
	char values[5][64];
    	//Coord co=getGPS(mapx, mapy);
	memset (values,0,sizeof (values));
	int edit_pos=0;
	char error[32];
	strcpy( error,"");
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	Image * menuwindow=ldImage("system/menuwindow.png");
	Image * hilite=ldImage("system/hilite.png");

	 Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
        memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	danzeff_load(); 
	if (!(danzeff_isinitialized())) { return 0; } 
	danzeff_moveTo(300,96);
	int blinkcounter=0;
	while(1) {
        while (1) {
		sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		} else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-26*4, 34);
               	draw_string( label2, 42, 48);
		int i,j;
		for (i=0; i<4; i++) {
               		draw_string( headers[i], 20, 73+15*i);
			if (i==current) {
				for (j=0; j<(signed int)strlen(values[i])+2; j++) {
					drawHiliteBar(hilite, 102+j*8, 69+15*i,1 ); 
					drawHiliteBar(hilite, 102+j*8, 77+15*i,1 ); 
				}
				if (blinkcounter++>10) 
               				draw_string( "-", 110+edit_pos*8, 79+15*i);
				if (blinkcounter++>18)
					blinkcounter=0;
			}
               		draw_string( values[i], 110, 73+15*i);
		}
               	draw_string( error, 35,200 );
	
               	draw_string( notes[current], 15,248 );
    		danzeff_render(); 
		char key= danzeff_readInput(cpad);

		if (key==DANZEFF_START) {
			beep();
			if (strlen(values[0])>2 ) 
				break;
			else
				strcpy(error,"INCORRECT VALUES ENTERED!!!"); translate (error);
		}
		if (wait>100) wait=21;
		wait++;
		if (wait>20) {
		switch (key) 
               { 
          case 0: 
          	break; 
         case 9: if (current>0) {
			current--;
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break; 
         case '\n': if (current<3) {
			current++; 
			edit_pos=0;
		}
		strcpy( error,"");
		beep();
		break;
         case DANZEFF_LEFT: if (edit_pos>0) edit_pos--;
		strcpy( error,"");
		beep();
		break; 
         case DANZEFF_RIGHT: if (edit_pos<lens[current]) edit_pos++;
		strcpy( error,"");
		beep();
		break;
         case DANZEFF_SELECT: 
		beep();
		if (menuwindow!=NULL)
			freeImage(menuwindow);
		if (hilite!=NULL)
			freeImage(hilite);
		 if (bg!=NULL)
                	free(bg);
		danzeff_free();
		return 0;
         case DANZEFF_START: beep(); break; 
	case 8: //delete
		beep();
		strcpy( error,"");
		deleteChar(values[current],edit_pos);
		break;
	case 7: //backspace		// MIB.42_4
		beep();
		strcpy( error,"");
		if(edit_pos>0)
		{
			--edit_pos;
			deleteChar(values[current],edit_pos);
		}
		break;

         default: 
		beep();
		strcpy( error,"");
		if ((signed int)strlen(values[current])<lens[current]) {
			insertChar(values[current],edit_pos,key);
			edit_pos++;
		}
		toUpperCase(values[current]);
             //fprintf(stdout,"You have input the key %c\n",key); 
             break; 
       }
	}
		flipScreen();

	}
	
	display_message("","SEARCHING...","",0);
	display_message("","SEARCHING...","",0);
	display_message("","SEARCHING...","",0);
	char address[256];
	sprintf(address,"%s,%s,%s %s",values[0],values[1],values[2],values[3]);
        //fprintf(stdout,"[%s]\n",address);	
	Coord min=getGPS(0,0);
	Coord max=getGPS(TILE_SIZE*TILE_NUM,TILE_SIZE*TILE_NUM);

	double minlat=min.lat, maxlat=max.lat, minlon=min.lon,maxlon=max.lon;
	if ( min.lat > max.lat) {
		maxlat=min.lat;
		minlat=max.lat;
	} 
	if ( min.lon > max.lon) {
		maxlon=min.lon;
		minlon=min.lon;
	}

	address_geolookup2(zipfile,values[0], values[3], values[1],values[2],minlat-0.1,minlon-0.1,maxlat+0.1,maxlon+0.1,0);
	if (zipcounter<1)
	{
		flipScreen();
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",0);
		display_message("NO EXACT MATCH FOUND !","","CONDUCTING RELAXED SEARCH...",300);
		address_geolookup2(zipfile,values[0], values[3], values[1],values[2],minlat-0.1,minlon-0.1,maxlat+0.1,maxlon+0.1,1); 
// MIB.42_8
		if (zipcounter<1)
		{
			flipScreen();
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",0);
			display_message("NO MATCH FOUND !","","CONDUCTING WIDE SEARCH...",300);
			address_geolookup2(zipfile,values[0], values[3], values[1],values[2],minlat-0.1,minlon-0.1,maxlat+0.1,maxlon+0.1,2); 
			if (zipcounter<1)
			{
				flipScreen();
				display_message("NO MATCHES FOUND !","","PRESS [X] TO CONTINUE",0);
				display_message("NO MATCHES FOUND !","","PRESS [X] TO CONTINUE",0);
				display_message("NO MATCHES FOUND !","","PRESS [X] TO CONTINUE",0);
				display_message("NO MATCHES FOUND !","","PRESS [X] TO CONTINUE",0);
				display_message("NO MATCHES FOUND !","","PRESS [X] TO CONTINUE",30000);
				wait=0;
			}
		}
// EoF MIB.42_8
	    }
	if (zipcounter>0) break;
	}

	danzeff_free();
	int cur=0;
	int timer=0;
	int topline=0;
	int i;

	while (!(cpad.Buttons & PSP_CTRL_CROSS)) {
                sceCtrlPeekBufferPositive(&cpad, 1);
                sceKernelDelayThread(1);

                if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>7/(333/Clock)) {
                        timer=0;
                        break;
                }
                if (cpad.Buttons & PSP_CTRL_SELECT) {

			if (menuwindow!=NULL)
				freeImage(menuwindow);
	 		if (bg!=NULL)
               			free(bg);
                        return -100000;
                } 

                if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>2/(333/Clock)) {
                        if (cur<zipcounter-1) {
                                cur++;
                                if (cur-topline>12)
                                        topline++;
                                beep();
                        }       
                        timer=0;
                }

                if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>2/(333/Clock)) {
                        timer=0;
                        if (cur>0) {
                                cur--;
                                if (cur<topline && topline>0)
                                        topline--;
                                beep();
                        }
                }


                timer++;
                if (timer>100) timer=11;
                if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
                if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
                }else
                        fillScreenRect(0x000000cc,12,28,455,232);
		strcpy(label1,"::: ADDRESS SEARCH RESULTS"); translate(label1);
		sprintf(values[0],"%s [%d] :::",label1,zipcounter);
        	draw_string( values[0], PSP_WIDTH/2-26*4, 34);
		drawHiliteBar(hilite,20,(cur-topline)*15+57,55 ); 
		drawHiliteBar(hilite,20,(cur-topline)*15+65,55 ); 


		for (i=0; i<13 && i<zipcounter; i++) {
		     sprintf(values[0],"%s, %s, %s %s",addrs[i+topline].street,addrs[i+topline].city,addrs[i+topline].state ,addrs[i+topline].zipcode);
                        toUpperCase(values[0]);
                        draw_string( values[0], 30, i*15+61);

                }


                flipScreen();
                sceKernelDelayThread(5);
        }

	Coord  c=getXY(addrs[cur].lat,addrs[cur].lon,basezoom);
	if (c.lon>0 && c.lon<TILE_SIZE*TILE_NUM && c.lat>0 && c.lat<TILE_SIZE*TILE_NUM){
		mapx=(long int)c.lon;
		mapy=(long int)c.lat;
		marker=1;
		lat1=addrs[cur].lat;
		lon1=addrs[cur].lon;
		mapx1=mapx;
		mapy1=mapy;
		if (attraction[0]==NULL)
			attraction[0] = ldImage("system/icons/attraction.png");
	} else {
		display_message("THIS LOCATION CANNOT","BE DISPLAYED ON THIS MAP","PRESS [X] TO CONTINUE",2000);
	}


	if (menuwindow!=NULL)
		freeImage(menuwindow);
	if (hilite!=NULL)
		freeImage(hilite);
	 if (bg!=NULL)
               	free(bg);
	return 0;
}


int map_upload_menu() {

	char label1[64]="::: WIFI MAP UPLOAD FORM :::"; translate(label1);
	char label2[64]="EDIT THE FIELDS BELOW AND PRESS [START] BUTTON"; translate(label2);
	int current=0;
	char headers[5][20] = { "MAP NAME" , "LATITUDE:", "LONGITUDE:", "BASE ZOOM", "MAP SIZE" };
	translate(headers[0]);
	translate(headers[1]);
	translate(headers[2]);
	translate(headers[3]);
	translate(headers[4]);
	char notes[5][64] = { "NOTE: SOME CHARACTERS ARE NOT SUPPORTED" , "NOTE: MUST BE IN DECIMAL FORMAT", "NOTE: MUST BE IN DECIMAL FORMAT", "RANGE: 0-14 (0 IS MOST DETAILED)", "MUST BE 4,8,16,32,64,128,256" };
	translate(notes[0]);
	translate(notes[1]);
	translate(notes[2]);
	translate(notes[3]);
	translate(notes[4]);
	int lens[5]= { 40,10,10,2,3};
	char values[5][64];
    	Coord co=getGPS(mapx, mapy);
	sprintf(values[0],"MAP_FOR_LAT_%10.6f__LON_%10.6f",co.lat, co.lon);
	sprintf(values[1],"%f",co.lat);
	sprintf(values[2],"%f", co.lon);
	sprintf(values[3],"2");
	sprintf(values[4],"16");
	int edit_pos=0;
	char error[32];
	strcpy( error,"");
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	Image * menuwindow=ldImage("system/menuwindow.png");
	Image * background=ldImage("system/background.png");
	Image * hilite=ldImage("system/hilite.png");
	danzeff_load(); 
	if (!(danzeff_isinitialized())) { return 0; } 
	danzeff_moveTo(300,96);
	int blinkcounter=0;
        while (1) {
		sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		if (background!=NULL)
			blitAlphaImageToScreen(0,0,PSP_WIDTH,PSP_HEIGHT,background,0,0);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		} else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-26*4, 34);
               	draw_string( label2, 58, 58);
		int i,j;
		for (i=0; i<5; i++) {
               		draw_string( headers[i], 20, 83+15*i);
			if (i==current) {
				for (j=0; j<(signed int)strlen(values[i])+2; j++) {
					drawHiliteBar(hilite,112+j*8, 79+15*i,1 ); 
					drawHiliteBar(hilite,112+j*8, 87+15*i,1 ); 
				}
				if (blinkcounter++>10) 
               				draw_string( "-", 120+edit_pos*8, 89+15*i);
				if (blinkcounter++>18)
					blinkcounter=0;
			}
               		draw_string( values[i], 120, 83+15*i);
		}
               	draw_string( error, 35,200 );
	
               	draw_string( notes[current], 15,248 );
    		danzeff_render(); 
		char key= danzeff_readInput(cpad);

		if (key==DANZEFF_START) {
			beep();
			if (check_fields(values[0], atof(values[1]), atof(values[2]), atoi(values[3]), atoi(values[4]))==1) 
				break;
			else
				strcpy(error,"INCORRECT VALUES ENTERED!!!"); translate(error);


		}

		switch (key) 
               { 
          case 0: 
          	break; 
         case 9: if (current>0) {
			current--;
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break; 
         case '\n': if (current<4) {
			current++; 
			edit_pos=0;
		}
		beep();
		strcpy( error,"");
		break;
         case DANZEFF_LEFT: if (edit_pos>0) edit_pos--;
		strcpy( error,"");
		beep();
		break; 
         case DANZEFF_RIGHT: if (edit_pos<lens[current]) edit_pos++;
		strcpy( error,"");
		beep();
		break;
         case DANZEFF_SELECT: 
		beep();
		if (menuwindow!=NULL)
			freeImage(menuwindow);
		if (background!=NULL)
			freeImage(background);
		if (hilite!=NULL)
			freeImage(hilite);
		danzeff_free();
		return 0;
         case DANZEFF_START: beep();break; 
	case 8: //delete
		beep();
		strcpy( error,"");
		deleteChar(values[current],edit_pos);
		break;
	case 7: //backspace		// MIB.42_4
		beep();
		strcpy( error,"");
		if(edit_pos>0)
		{
			--edit_pos;
			deleteChar(values[current],edit_pos);
		}
		break;

         default: 
		beep();
		strcpy( error,"");
		if ((signed int)strlen(values[current])<lens[current]) {
			insertChar(values[current],edit_pos,key);
			edit_pos++;
		}
		toUpperCase(values[current]);
             //fprintf(stdout,"You have input the key %c\n",key); 
             break; 
       }
		flipScreen();

	}

	danzeff_free();
	sprintf (dirname,"maps/_%s", values[0]);
	latitude=atof(values[1]);
	longitude=atof(values[2]);
	basezoom=atoi(values[3]);
	mapsize=atoi(values[4]);
	memset(messages,0,sizeof(messages));
// start upload thread 
	char tname[32];
	u64 tick;	
	sceRtcGetCurrentTick(&tick);
	sprintf(tname,"WIFI#%lo",(long unsigned int)tick);	// MIB.42 - just to get rid of compiler warning
	if (thid_wifi>0)                                        // MIB.42_5
                sceKernelTerminateDeleteThread(thid_wifi);
        //thid_wifi = sceKernelCreateThread(tname, wget, 0x11, 512 * 1024, PSP_THREAD_ATTR_USER, NULL);
        thid_wifi = sceKernelCreateThread(tname, wget, 0x11,  4*1024, PSP_THREAD_ATTR_USER, 0);
	if (wifithid>=0){
   		int ret=sceKernelStartThread(thid_wifi, 0, NULL);
		if (ret!=0) ms_write_log("failed to start wifi\n",wifithid);
        } else {
		ms_write_log("Could not start wifi update thread\n");
	}

	strcpy(label1, "::: WIFI MAP UPLOAD STATUS :::"); translate(label1);
	strcpy(label2, "PRESS [SELECT] TO CANCEL"); translate(label2);

        while (!(cpad.Buttons & PSP_CTRL_SELECT)) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);
		if (background!=NULL)
			blitAlphaImageToScreen(0,0,PSP_WIDTH,PSP_HEIGHT,background,0,0);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		}else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-26*4, 34);
		int i;
		for ( i=0; i<15; i++)
                	draw_string_no_ctrl( messages[i], 30, 50+i*12);
			
               	draw_string( label2, 15,248 );

		flipScreen();
	}

	killwifi=1;


	if (menuwindow!=NULL)
		freeImage(menuwindow);
	if (background!=NULL)
		freeImage(background);
	if (hilite!=NULL)
		freeImage(hilite);

	return 0;
}

int edit_line(char * line) {
	int timer=0;
	char templine[64];
	int changed=0;
	strcpy(templine, line);
	//fprintf(stdout,"{{%s}}\n", templine);
	danzeff_load();
        if (!(danzeff_isinitialized())) { return 0; }
        danzeff_moveTo(300,96);
	Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
	memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);
	int edit_pos=strlen(line)-1;
	if (edit_pos<0) edit_pos=0;
	while (1) {
		sceCtrlPeekBufferPositive(&cpad, 1);
                sceKernelDelayThread(1);
		if (bg!=NULL)
			memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		fillScreenRect(0x00000000,26,50,8*53,13);
		fillScreenRect(0xaaaaaaaa,25,49,8*53,13);

		danzeff_render();
                char key= danzeff_readInput(cpad);
		if (key==DANZEFF_SELECT) {
			beep();
			break;
		}
		if (key==DANZEFF_START) {
			beep();
			strcpy(line,templine);
			changed=1;
			break;
		}
		switch (key)
               {
          case 0:  break;
          case 9: templine[edit_pos]++; 
		beep();
		break;
          case 10:   templine[edit_pos]--;	
		beep();
		break;
          //case '\n': beep();break;
	
         case DANZEFF_LEFT: if (edit_pos>0) edit_pos--;
		beep();
                break;
         case DANZEFF_RIGHT: if (edit_pos<53) edit_pos++;
			if (edit_pos>strlen(templine))
				strcat(templine," ");
		beep();
                break;
        case 8: //delete
		beep();
                deleteChar(templine,edit_pos);
                break;
        case 7: //backspace             // MIB.42_4
		beep();
                if(edit_pos>0)
                {
                        --edit_pos;
                        deleteChar(templine,edit_pos);
                }
                break;
         default:
		beep();
                if ((signed int)strlen(templine)<53) {
                        insertChar(templine,edit_pos,key);
                        edit_pos++;
                }
                toUpperCase(templine);
             break;
        }

		if (timer>100) timer=21;
		timer++;
               	draw_string( templine, 26, 51);
		if (timer%20>10)
               		draw_string_no_ctrl( "_", 26+8*edit_pos, 53);
		flipScreen();

	}
	if (bg!=NULL)
		free(bg);
	 danzeff_free();
	return changed;
}

int configuration() {
	char label[64]="::: CONFIGURATION :::"; translate(label);
        int i=0, timer=0;
	int topline=0;
	char line[60];
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);
	int lines=100;
	char * options[lines];
	FILE * fp=fopn("system/config.txt","r");
	if (fp!=NULL) {
	for (i=0; i<lines; i++)	 {
		options[i]=(char*)malloc(64*sizeof(char));
		if (options[i]==NULL) {
			int j;
			for (j=0;j<i; j++)
				free(options[j]);
			fclose(fp);
			return -1;
		} else 
			memset(options[i],0,64*sizeof(char));
	}
	Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
	memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	i=0;
	 while(fgets(line,60,fp) != NULL && i<100 )  {
		if (line[strlen(line)-1]=='\n')
			line[strlen(line)-1]=0;
		strcpy(options[i++],line);
	}
	 
	fclose(fp);
	int size=i;
	Image * menuwindow=ldImage("system/menuwindow.png");

        while (!(cpad.Buttons & PSP_CTRL_CIRCLE)) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);


		if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>2) {
			break;
		}
		if (cpad.Buttons & PSP_CTRL_SELECT)
			break;
		if ((cpad.Buttons & PSP_CTRL_CROSS) && timer>10/(333/Clock)) {
			timer=0;
			if (edit_line(options[topline])==1){
				//save file
				fp=fopn("system/config.txt","w");
				if (fp!=NULL) {
					for (i=0; i<size; i++)
						fprintf(fp,"%s\n",options[i]);
					fclose(fp);
					readConfig();
					unload_group(4096,zipfile,datatype);
				}
			}
		}

		if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>4/(333/Clock)) {
				if (size-topline>17)
					topline++;
                        timer=0;
                }

        	if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>2/(333/Clock)) {
                        timer=0;
			if (topline>0)
				topline--;
                }


                timer++;
                if (timer>100) timer=11;
		if (bg!=NULL)
			memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		 } else
			fillScreenRect(0x000000cc,12,28,455,232);
		draw_string( label, PSP_WIDTH/2- 12*8, 34);
		if (timer%10>5) {
			draw_string( ">", 20, 51);
			draw_string( ">", 15, 51);
		}
                for (i=0; i<17 && i<size; i++) {
			strcpy(line,options[i+topline]);
			toUpperCase(line);
			if (line[0]=='#')
                		draw_comment_string( line, 26, i*12+51);
			else
                		draw_string_no_ctrl( line, 26, i*12+51);

                }

			
		flipScreen();
                sceKernelDelayThread(1);


        }
	for (i=0; i<lines; i++) {
		if (options[i]!=NULL)
			free(options[i]);
	}
	if (bg!=NULL)
		free(bg);
	if (menuwindow!=NULL)
		freeImage(menuwindow);

	} else return -1;
	return 1;
}

int helpscreen() {
	char label[64]="::: HELP :::"; translate(label);
        int i=0, timer=0;
	int topline=0;
	char line[60];
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);
	int lines=100;
	char * options[lines];
	FILE * fp=fopn("system/help.txt","r");
	if (fp!=NULL) {
	for (i=0; i<lines; i++)	 {
		options[i]=(char*)malloc(64*sizeof(char));
		if (options[i]==NULL) {
			int j;
			for (j=0;j<i; j++)
				free(options[j]);
			fclose(fp);
			return -1;
		} else 
			memset(options[i],0,64*sizeof(char));
	}
	Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
	memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	i=0;
	memset(line,0,sizeof(line));
	 while(fgets(line,60,fp) != NULL && i<100 )  {
		if (line[strlen(line)-1]=='\n' || line[strlen(line)-1]=='\r')
			line[strlen(line)-1]=0;
		if (line[strlen(line)-1]=='\n' || line[strlen(line)-1]=='\r')
			line[strlen(line)-1]=0;
		strcpy(options[i++],line);
		memset(line,0,sizeof(line));
	}
	 

	int size=i;
	Image * menuwindow=ldImage("system/menuwindow.png");

        while (!(cpad.Buttons & PSP_CTRL_CIRCLE)) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);


		if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>2) {
			break;
		}
		if (cpad.Buttons & PSP_CTRL_SELECT)
			break;

		if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>1) {
				if (size-topline>17)
					topline++;
                        timer=0;
                }

        	if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>1) {
                        timer=0;
			if (topline>0)
				topline--;
                }


                timer++;
                if (timer>100) timer=11;
		if (bg!=NULL)
			memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		 } else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label, PSP_WIDTH/2- 12*4, 34);
                for (i=0; i<17 && i<size; i++) {
			strcpy(line,options[i+topline]);
			//toUpperCase(line);
                	draw_string( line, 26, i*12+51);

                }

			
		flipScreen();
                sceKernelDelayThread(1);


        }
	for (i=0; i<lines; i++) {
		if (options[i]!=NULL)
			free(options[i]);
	}
	if (bg!=NULL)
		free(bg);
	if (menuwindow!=NULL)
		freeImage(menuwindow);
	fclose(fp);

	} else return -1;
	return 1;
}

#ifndef GENERIC
int gps_info() {
	char label1[32]="GPS INFORMATION"; translate(label1);
	char label2[16]="GPS STATE"; translate(label2);
	char label3[64]="------------------ SATELLITE INFO --------------------"; translate(label3);
        int timer=0;
        int fix;
	int oldclock=Clock;
	Clock=satinfofrequency;
        scePowerSetClockFrequency(Clock,Clock,Clock/2);
        sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);
        char line[64];
        char state[4][11] = { "  OFF     ", "ACTIVATING","ACTIVATING", "  ON      " };
	int i;
	for (i=0; i<4; i++)
		translate(state[i]);
	char labels[17][16]={"SAT-IN-VIEW:", "FIXED:", "HDOP:", "SAT ID:", "ELEVATION:", "AZIMUTH:", "SNR:", "FIX:", "TIME:", "LAT:", "LON:", "ALT:", "SPEED:", "BEARING:", "LOC:", "CPU:"};
	for (i=0; i<16; i++)
		translate(labels[i]);
        Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
        memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

        Image * menuwindow=ldImage("system/menuwindow.png");

        while (!((cpad.Buttons & PSP_CTRL_SELECT )&& timer>10/(333/Clock))) {
                sceCtrlPeekBufferPositive(&cpad, 1);
                sceKernelDelayThread(1);
                timer++;
                if (timer>100)
                        timer=20;
		if ((cpad.Buttons &  PSP_CTRL_UP) && timer>7/(333/Clock)) {
                        if (Clock<333) {
				if (Clock<111)
                                	Clock=111;
				else
                               		Clock+=111;
                                scePowerSetClockFrequency(Clock,Clock,Clock/2);
                                timer=0;
                        }
                }
                if ((cpad.Buttons &  PSP_CTRL_DOWN) && timer>7/(333/Clock)) {
                        if (Clock>111) {
                                Clock-=111;
                                scePowerSetClockFrequency(Clock,Clock,Clock/2);
                                timer=0;
                        } else {
				if (Clock==110)
                                	Clock=40;
			}
                }
                if ((cpad.Buttons &  PSP_CTRL_LEFT) && timer>7/333/Clock) {
			timer=0;
        		if (gpsState == 0x3) {
				initLocation--;
                		sceUsbGpsSetInitDataLocation(initLocation);
                		sceUsbGpsGetInitDataLocation(&getLocation);
			}
		}
                if ((cpad.Buttons &  PSP_CTRL_RIGHT) && timer>7/333/Clock) {
			timer=0;
        		if (gpsState == 0x3) {
				initLocation++;
                		sceUsbGpsSetInitDataLocation(initLocation);
                		sceUsbGpsGetInitDataLocation(&getLocation);
			}
		}


                if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
                if (menuwindow!=NULL) {
                        blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
                        blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
                }else
                        fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( label1, PSP_WIDTH/2-strlen(label1)*4, 34);
                sprintf(line,"%9s: %s   %s %02d/%02d/%04d %02d:%02d:%02d (GMT)",label2, state[gpsState],labels[8], gpsd.month, gpsd.date, gpsd.year, gpsd.hour, gpsd.minute, gpsd.second);
                draw_string(line, 20, 50);
                sprintf(line,"%s     %9.6f  %s %10.6f  %s  %5.1f",labels[9], gpsd.latitude,labels[10], gpsd.longitude, labels[11],gpsd.altitude);
                draw_string(line, 20, 70);
                sprintf(line,"%s     %5.2f        %s%03.0f      %s   %ld",labels[12], gpsd.speed,labels[13], gpsd.bearing,labels[14], getLocation);
                draw_string(line,  20, 80);
                sprintf(line,"%s     %d Mhz",labels[15], scePowerGetCpuClockFrequencyInt());
                draw_string(line,  20, 90);
                int j;
                fix=0;
                draw_string(label3, 20, 100);
                for (j=0; j<satd.satellites_in_view && j<16; j++) {
                        sprintf(line,"%s%03d  %s%02d  %s%03d  %s%02d  %s%d",labels[3], satd.satinf[j].id,labels[4], satd.satinf[j].elevation,labels[5], satd.satinf[j].azimuth,labels[6], satd.satinf[j].snr,labels[7], satd.satinf[j].good);
                        draw_string(line,  20, 110+j*9);
                if ( satd.satinf[j].good==1)
                        fix++;
                }
                sprintf(line,"%s %02d         %s %02d        %s %5.1f",labels[0], satd.satellites_in_view,labels[1],fix,labels[2], gpsd.hdop);
                draw_string(line,  20, 60);

                flipScreen();
                sceKernelDelayThread(5);


        }
	Clock=oldclock;
       	scePowerSetClockFrequency(Clock,Clock,Clock/2);

        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
        memcpy( getVramDisplayBuffer(),bg, FRAMEBUFFER_SIZE);
        flipScreen();
        sceKernelDelayThread(1);

        if (bg!=NULL)
                free(bg);
        if (menuwindow!=NULL)
                freeImage(menuwindow);
        return 1;
}



#else
int gps_info() {
        int timer=0;
        sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);
        char line[64];

        Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
        memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

        Image * menuwindow=ldImage("system/menuwindow.png");

        while (!((cpad.Buttons & PSP_CTRL_SELECT )&& timer>10/(333/Clock))) {
                sceCtrlPeekBufferPositive(&cpad, 1);
                sceKernelDelayThread(1);
                timer++;
                if (timer>100)
                        timer=20;
		if ((cpad.Buttons &  PSP_CTRL_UP) && timer>7/(333/Clock)) {
			if (Clock<333) {
				Clock+=111;
                        	scePowerSetClockFrequency(Clock,Clock,Clock/2);
				timer=0;
			}
		}
		if ((cpad.Buttons &  PSP_CTRL_DOWN) && timer>7/(333/Clock)) {
			if (Clock>111) {
				Clock-=111;
                        	scePowerSetClockFrequency(Clock,Clock,Clock/2);
				timer=0;
			}
		}
		if ((cpad.Buttons &  PSP_CTRL_SQUARE) && timer>7/(333/Clock)) {
			timer=0;
			if (shownmea==1)
				shownmea=0;
			else
				shownmea=1;
			
		}

                if (bg!=NULL)
                        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
                if (menuwindow!=NULL) {
                        blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
                        blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
                }else
                        fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( "GPS INFORMATION", PSP_WIDTH/2-strlen("GPS INFORMATION")*4, 34);
		if (isconnected)
                	sprintf(line,"GPS STATE: ON     TIME: %02ld/%02ld/%02ld %02ld:%02ld:%02ld(GMT)",  date%10000/100,date/10000,date%100, ltime/10000, ltime%10000/100, ltime%100);
		else
                	sprintf(line,"GPS STATE: OFF    TIME: %02ld/%02ld/%02ld %02ld:%02ld:%02ld(GMT)",  date%10000/100,date/10000,date%100, ltime/10000, ltime%10000/100, ltime%100);
                draw_string(line,  20, 50);
		if (dms==1) {
			double plat= latitude;
			double plon= longitude;
		char NS='N';
		char EW='E';
		if (plat<0) {
			plat*=-1;
			NS='S';
		} else if (plat==0)
			NS=' ';
		if (plon<0) {
			plon*=-1;
			EW='W';
		}else if (plon==0)
			EW=' ';
                	sprintf(line,"LAT:      %c%3.0f.%02.05f LON: %c%3.0f.%02.05f ALT:  %5.1f", NS,floor(plat), 60*(plat-floor(plat)), EW, floor(plon),60*(plon-floor(plon)),  altitude);
		} else
                	sprintf(line,"LAT:         %9.6f  LON: %10.6f  ALT:  %5.1f", latitude, longitude, altitude);
                draw_string(line,  20, 70);
                 sprintf(line,"SPEED:     %5.2f        BEARING:%03.0f      QUALITY: %d", speed, course, quality);
                draw_string(line,  20, 80);
                sprintf(line,"CPU:     %d Mhz", scePowerGetCpuClockFrequencyInt());
                draw_string(line,  20, 90);
                int j,i;
		if (shownmea) {
                	sprintf(line,"------------------ NMEA SENTENCES --------------------");
                	draw_string(line, 20, 100);
			char temp[60];
			int ln=0;
			j=0;i=0;
			memset(temp,0,sizeof(temp));
			//fprintf(stdout,"[%s]\n",buffer);
			while (j<1024 && buffer[j]>0) {
				temp[i]=buffer[j];
				j++;
				i++;
				if (i>55 ||  buffer[j]==0  ||  buffer[j]=='\n' ) {
					temp[i]=0;
					//fprintf(stdout,"%s\n",temp);
                        		draw_string_no_ctrl(temp,  20, 110+(ln++*9));
					i=0;
					memset(temp,0,sizeof(temp));
				}
			}

		} else {
                	sprintf(line,"------------------ SATELLITE INFO --------------------");
                	draw_string(line, 20, 100);
			int satc=0;
                	for (j=0; j<gsv.satellites_in_view && j<16; j++) {
                        	sprintf(line," SAT ID:%03d    ELEVATION:%02d    AZIMUTH:%03d    SNR:%02d  ", gsv.satellites[j].prn, gsv.satellites[j].elevation, gsv.satellites[j].azimuth,gsv.satellites[j].snr);
                        	draw_string(line,  20, 110+(satc++*9));
                	}
		}
                sprintf(line,"SAT-IN-VIEW: %02d         FIXED: %02d        HDOP: %5.1f",  satellites_in_view, satellites, hdop);
                draw_string_no_ctrl(line,  20, 60);

                flipScreen();
                sceKernelDelayThread(5);


        }
        memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
        memcpy( getVramDisplayBuffer(),bg, FRAMEBUFFER_SIZE);
        flipScreen();
        sceKernelDelayThread(1);

        if (bg!=NULL)
                free(bg);
        if (menuwindow!=NULL)
                freeImage(menuwindow);
        return 1;
}
#endif








int display_menu(char * t, char options[][60] , int size, int cur ) {
        int i, timer=0;
	int topline=0;
	char title[64];
	char filename[128];
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);
	int circle=0;
	Image *icons[18];
	short imgindx[size];
	strcpy(title,t);
	//let's display icons for this menu...
	if (strcmp(title,"::: SELECT ATTRACTION TYPE :::")==0) {
	translate(title);
	char icon_names[19][10] = { "DEFAULT", "AIRPORT", "TRAFFIC", "FIX", "HOTEL", "ATTRACT", "BANK", "FRIEND", "SHOP", "BAR", "CAMERA", "GAS", "PARK", "CINEMA", "CLUB", "HOSPITAL", "ROUTE", "FOOD" };
	char icon_hints[19][10] = { "DEFAULT", "AIRPORT", "CONGESTI", "REPAIR", "MOTEL", "INTEREST", "MONEY", "POI", "MARKET", "PUB", "SPEED", "FUEL", "PARK", "MOVIE", "DANCE", "HOSPITAL", "WAY", "RESTAUR" };
	int j;
	for (i=0; i<size; i++) {
		imgindx[i]=0;
		for (j=0; j<18; j++) {
			strcpy(filename,options[i]);
			toUpperCase(filename);
			if (strstr(filename,icon_names[j])!=NULL || strstr(filename,icon_hints[j])!=NULL)
				imgindx[i]=j;	
		}
	}
	for (i=0; i<18; i++) {
		sprintf(filename,"system/icons/%s.png",icon_names[i]);
		icons[i]=ldImage(filename);
	}
	} else {
		for (i=0; i<18; i++)
			icons[i]=NULL;
		for (i=0; i<size; i++)
			imgindx[i]=0;
	}

	Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
	memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	Image * menuwindow=ldImage("system/menuwindow.png");
	Image * hilite=ldImage("system/hilite.png");

        while (!((cpad.Buttons & PSP_CTRL_CROSS )&& timer>10/(333/Clock))) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);


		if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>7/(333/Clock)) {
			timer=0;
			circle=1;	
			break;
		}
		if ((cpad.Buttons & PSP_CTRL_SELECT) && timer>10/(333/Clock)) {
			if (bg!=NULL)
				free(bg);
			if (menuwindow!=NULL)
				freeImage(menuwindow);
			if (hilite!=NULL)
				freeImage(hilite);
			for (i=0; i<18; i++) {
				if(icons[i]!=NULL)
					freeImage(icons[i]);
				}
			return -100000;

		}

		if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>4/(333/Clock)) {
                        if (cur<size-1) {
                                cur++;
				if (cur-topline>12)
					topline++;
				beep();
			}	
                        timer=0;
                }

        	if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>4/(333/Clock)) {
                        timer=0;
                        if (cur>0) {
                                cur--;
				if (cur<topline && topline>0)
					topline--;
				beep();
			}
                }


                timer++;
                if (timer>100) timer=11;
		if (bg!=NULL)
			memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		sprintf(filename,"VER: %s",VERSION);
               	draw_string( filename, 376, 251);
		if (menuwindow!=NULL) {
			blitAlphaImageToScreen(0,0,455,122,menuwindow,12,28);
			blitAlphaImageToScreen(0,18,455,110,menuwindow,12,150);
		}else
			fillScreenRect(0x000000cc,12,28,455,232);
                draw_string( title, PSP_WIDTH/2-strlen(title)*4, 34);
		drawHiliteBar(hilite,20,(cur-topline)*15+54,55 ); 
		drawHiliteBar(hilite,20,(cur-topline)*15+62,55 ); 
                for (i=0; i<13 && i<size; i++) {
			strcpy(filename,options[i+topline]);
			//toUpperCase(filename);
                	draw_string_no_und( filename, 30, i*15+58);
			if (icons[imgindx[i+topline]]!=NULL) 
				blitAlphaImageToScreen(0,0,14,14,icons[imgindx[i+topline]],18,i*15+54);

                }

			
		flipScreen();
                sceKernelDelayThread(5);


        }
	memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
	memcpy( getVramDisplayBuffer(),bg, FRAMEBUFFER_SIZE);
	flipScreen();
        sceKernelDelayThread(1);

	if (bg!=NULL)
		free(bg);
	if (hilite!=NULL)
		freeImage(hilite);
	if (menuwindow!=NULL)
		freeImage(menuwindow);
	for (i=0; i<18; i++) {
	if(icons[i]!=NULL)
		freeImage(icons[i]);
	}
	if (circle==1) {
		cur++;
		return -cur;
	} else
		return cur;
}


int display_icons_menu(int cur ) {
	char label[64]="::: SELECT ACTION :::"; translate(label);
        int  timer=0;
	sceCtrlSetSamplingCycle(0);
        sceCtrlSetSamplingMode(1);

	Color * bg= (Color *) malloc ( FRAMEBUFFER_SIZE);
	memcpy(bg, getVramDrawBuffer(), FRAMEBUFFER_SIZE);

	Image * menubuttons=ldImage("system/menubuttons.png");
	Image * menuwindow=ldImage("system/menuwindow.png");

        while (!((cpad.Buttons & PSP_CTRL_CROSS )&& timer>10/(333/Clock))) {
	 	sceCtrlPeekBufferPositive(&cpad, 1); 
                sceKernelDelayThread(1);


		if ((cpad.Buttons & PSP_CTRL_CIRCLE) && timer>7/(333/Clock)) {
			timer=0;
			break;
		}
		if ((cpad.Buttons & PSP_CTRL_SELECT) && timer>10/(333/Clock)) {
			if (bg!=NULL)
				free(bg);
			if (menubuttons!=NULL)
				freeImage(menubuttons);
			if (menuwindow!=NULL)
				freeImage(menuwindow);
			return -100000;

		}

		if ((cpad.Buttons & PSP_CTRL_DOWN || cpad.Ly >= 0xD0) && timer>10/(333/Clock)) {
			if (cur<8)
				cur+=4;
			timer=0;
			beep();
                }

        	if ((cpad.Buttons &  PSP_CTRL_UP || cpad.Ly <= 0x30) && timer>10/(333/Clock)) {
                        timer=0;
			beep();
			if (cur>3)
				cur-=4;
                }
        	if ((cpad.Buttons &  PSP_CTRL_LEFT || cpad.Lx <= 0x30) && timer>10/(333/Clock)) {
                        timer=0;
			beep();
			if (cur!=0 && cur!=4 && cur!=8)
				cur--;

		}
        	if ((cpad.Buttons &  PSP_CTRL_RIGHT || cpad.Lx >= 0xD0) && timer>10/(333/Clock)) {
                        timer=0;
			beep();
			if (cur!=3 && cur!=7 && cur!=11)
				cur++;

		}
                timer++;
                if (timer>100) timer=11;
		if (bg!=NULL)
			memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
		if (menuwindow!=NULL)  {
			blitAlphaImageToScreen(0,0,358,122,menuwindow,34,28);
			blitAlphaImageToScreen(0,38,358,90,menuwindow,34,150);

			blitAlphaImageToScreen(400,0,55,122,menuwindow,392,28);
			blitAlphaImageToScreen(400,38,55,90,menuwindow,392,150);
		}
                draw_string( label, PSP_WIDTH/2-26*3, 33);
		if (menubuttons!=NULL) {
			blitAlphaImageToScreen(0,0,400,60,menubuttons,40,50);
			if (fakefeed==1)
				blitAlphaImageToScreen(0,61,100,60,menubuttons,40,112);
			else
				blitAlphaImageToScreen(0,181,100,60,menubuttons,40,112);
			if (Clock<=222)
				blitAlphaImageToScreen(100,61,100,60,menubuttons,140,112);
			else
				blitAlphaImageToScreen(100,181,100,60,menubuttons,140,112);
			if (showpanels==1)
				blitAlphaImageToScreen(200,61,100,60,menubuttons,240,112);
			else
				blitAlphaImageToScreen(200,181,100,60,menubuttons,240,112);
			blitAlphaImageToScreen(300,61,100,60,menubuttons,340,112);

			blitAlphaImageToScreen(0,121,400,60,menubuttons,40,174);
			blitAlphaImageToScreen(303,185,114,72,menubuttons,33+100*(cur%4),45+61*(cur/4));
			if (timer%(30/(333/Clock))<15/(333/Clock))	
				blitAlphaImageToScreen(303,185,114,72,menubuttons,33+100*(cur%4),45+61*(cur/4));

		}

		flipScreen();
                sceKernelDelayThread(5/(333/Clock));


        }
	memcpy( getVramDrawBuffer(),bg, FRAMEBUFFER_SIZE);
	memcpy( getVramDisplayBuffer(),bg, FRAMEBUFFER_SIZE);
	flipScreen();
        sceKernelDelayThread(1);

	if (bg!=NULL)
		free(bg);
	if (menubuttons!=NULL)
		freeImage(menubuttons);
	if (menuwindow!=NULL)
		freeImage(menuwindow);
		return cur;

}


void load_coords(char* zipfile) {
        FILE *fp;
        char line[60];
        char xstr[30], ystr[30];
	Coord c;
        int rd=0;
	ftx=fty=0;
	basezoom=2;
	if (datatype==1) {
		ftx=(double)gpsfsGetX();
		fty=(double)gpsfsGetY();
		basezoom=gpsfsGetBaseZoom();
               	c=getLatLong((int)ftx,(int)fty,basezoom);
		//printf("lat=%f lon=%f lh=%f lw=%f\n", c.lat, c.lon,c.latHeight, c.lonWidth);
		return;
	} else {
		sprintf(line, "%s/coords.txt",zipfile);
		 fp = fopn(line, "r");
	}
        if (fp==NULL) {
                ms_write_log("load_coords:::couldn't open file: %s\n", "coords.txt");
		lat=lon=lat1=lon1=0;
                return;

        }

        if(fgets(line,60,fp) != NULL) {
                rd=sscanf(line,"%s %s %d",  xstr, ystr , &basezoom);
                if (rd<3) {
                        ms_write_log("load_coords:::couldn't read all values %d\n", rd);
			lat=lon=0;
                } else {
			ftx=atof(xstr);
			fty=atof(ystr);

                	c=getLatLong(atoi(xstr),atoi(ystr),basezoom);
			ms_write_log("lat=%f lon=%f lh=%f lw=%f\n", c.lat, c.lon,c.latHeight, c.lonWidth);
		}

        } else
		lat=lon=0;


        fclose(fp);

}


Coord getGPS (int x, int y) {
	Coord c = getLatLong((int)(x/TILE_SIZE+ftx),(int)(y/TILE_SIZE+fty-1),basezoom);
	c.lon=c.lon+x%TILE_SIZE*c.lonWidth/TILE_SIZE;
	c.lat=c.lat-y%TILE_SIZE*c.latHeight/TILE_SIZE;
	return c;
}
/*
//puts x value in Coord.lon and y value in Coord.lat
Coord getXY(double lat, double lon) {
	int x=ftx;
	int y=fty-1;
	Coord c;

	c=getLatLong(x,y,basezoom);
	while (c.lon<lon) 
		c=getLatLong(++x,y,basezoom);
	while (c.lat>lat) 
		c=getLatLong(x,++y,basezoom);
	x--;
	y--;
	c=getLatLong(x,y,basezoom);

	c.lon=(x-ftx)*TILE_SIZE+(lon-c.lon)*TILE_SIZE/c.lonWidth;
	c.lat=(y-fty)*TILE_SIZE+(c.lat-lat)*TILE_SIZE/c.latHeight+TILE_SIZE;
	return c;
}
*/



int detect_size(char *zipfile) {
	int maxsize=2048;
	char filename[128];
	Image * last = NULL;
	Image * first = NULL;
	//check png vs jpg
	if (datatype==1) {
		return gpsfsGetMapDimension();
	} else {
		sprintf(filename, "%s/1x/000/1x000000.jpg",zipfile);
		first=loadfromdir(filename);
	}

	if (first==NULL) {
		strcpy(filetype	, "png");
	} else {
		strcpy(filetype	, "jpg");
		unloadmap(filename);
	}

	while (last == NULL && maxsize>1) {
		maxsize=maxsize/2;
			sprintf(filename, "%s/1x/%03d/1x%03d%03d.%s",zipfile,(maxsize-1),(maxsize-1),(maxsize-1),filetype);
			last=loadfromdir(filename);
	}
	unloadmap(filename);
	return maxsize;
}

int get_zoom(int tile_num) {
	int tn=tile_num;
	int power=0;
	while (tn!=1) {
		tn=tn/2;
		power++;
	}
	return power;
}

int powerOf(int p){
	int two=1;
	int i;
	for (i=0; i<p; i++)
		two*=2;
	return two;
}


static void cleanup_output(void)
{
	running=0;
/*
        FILE *file;
        int empty;

        fclose(stdout);
        fclose(stderr);

        file = fopn(STDOUT_FILE, "rb");
        if ( file ) {
                empty = (fgetc(file) == EOF) ? 1 : 0;
                fclose(file);
                if ( empty ) {
                        remove(STDOUT_FILE);
                }
        }
        file = fopn(STDERR_FILE, "rb");
        if ( file ) {
                empty = (fgetc(file) == EOF) ? 1 : 0;
                fclose(file);
                if ( empty ) {
                        remove(STDERR_FILE);
                }
        }
*/
}





int readchar(char *pvec)
{
    int ch;
    if (*pvec == 0) {
        ch = -1;
    }
    else {
        ch = *pvec++;
    }
    return ch;
}





int garbage_collector (SceSize args, void *argp) {
	int oldzoom=zm;
	
	while (running) {

		if (!idle) {
		while (tlock==1)
			sceKernelDelayThread(1);
		tlock=1;
        	imglist_garbagecollect();
		cleanup(mapx,mapy,zm,zipfile,datatype);
		if (zm!=oldzoom) {
			//fprintf(stdout,".\n");
			unload_group(zm,zipfile,datatype);
			oldzoom=zm;
		} 

        	imglist_garbagecollect();
        	tlock=0;
	}

	sceKernelDelayThread(1000000);
	}
	return 0;
}


int cachemngr (SceSize args, void *argp) {
	int tx;
	int ty;
	int tyfix;
	int topx, topy; 
	int oldzoom=zm;
	char filename[128]; 

	while (running) {
		if (!idle) {
		tx=  (mapx/zm - PSP_WIDTH/2 - TILE_SIZE-RADIUS)/TILE_SIZE*TILE_SIZE;
		ty=  (mapy/zm - PSP_HEIGHT/2 - TILE_SIZE-RADIUS)/TILE_SIZE*TILE_SIZE;
		if (tx<0) tx=0;
		if (ty<0) ty=0;
		topx=tx+TILE_SIZE*4;
		if (topx>TILE_NUM*TILE_SIZE/zm)
			topx=TILE_NUM*TILE_SIZE/zm;
		topy=ty+TILE_SIZE*4;
		if (topy>TILE_NUM*TILE_SIZE/zm)
			topy=TILE_NUM*TILE_SIZE/zm;

		tyfix=ty;



	while (tx < topx ) {
		ty=tyfix;
		while (ty < topy ) {
			if (zm!=oldzoom)
				break;
			sceKernelDelayThread(1);
			if (datatype==1)
				sprintf(filename,"%dx%04d%04d.GPS", zm, (int)ty/TILE_SIZE, (int) tx/TILE_SIZE);
			else
				sprintf(filename,"%s/%dx/%03d/%dx%03d%03d.%s",zipfile, zm, (int)ty/TILE_SIZE, zm, (int)ty/TILE_SIZE, (int) tx/TILE_SIZE,filetype);
				while (tlock==1)
					sceKernelDelayThread(1);
				tlock=1;
			if (tx > mapx/zm - PSP_WIDTH/2 - TILE_SIZE-RADIUS &&  tx < mapx/zm + PSP_WIDTH/2+RADIUS && ty > mapy/zm - PSP_HEIGHT - TILE_SIZE-RADIUS && ty < mapy/zm + PSP_HEIGHT+RADIUS)  {
				if (datatype==1)
					loadfromgpsfs((int) tx/TILE_SIZE,(int)ty/TILE_SIZE,zm,TILE_NUM);
				else
					loadfromdir_check4blank(filename,nightmode);
			} else 
				unloadmap(filename);

			tlock=0;

			ty+=TILE_SIZE;
		}
		if (zm!=oldzoom) {
			oldzoom=zm;
			break;
		}
		
		tx+=TILE_SIZE;
	}

	}
	sceKernelDelayThread(2);
	}
	return 0;
}


 /* Exit callback */
int exit_callback(int arg1, int arg2, void *common)
{
	cleanup_output();
        sceKernelExitGame();
        return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
        int cbid;

        cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
        sceKernelRegisterExitCallback(cbid);

        sceKernelSleepThreadCB();

        return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
        int thid = 0;

        thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
        if(thid >= 0)
        {
                sceKernelStartThread(thid, 0, 0);
        }

	MP3_module_start(0,0);	// MIB.42_7

        return thid;
}


void draw_zoom_scale(int x,int y,Image * zs, int zoom , int maxzoom) {
	int i=0;
	if (maxzoom<2)
		return;
	blitAlphaImageToScreen(0,0,19,3,zs,x,y);
	for (i=0; i<maxzoom; i++) {
		blitAlphaImageToScreen(0,3,19,12,zs,x,y+3+11*i);
	}
	blitAlphaImageToScreen(0,16,19,10,zs,x,y+3+11*(zoom-1));

}



#ifndef GENERIC
int main_thread (SceSize args, void *argp)
{
        strcpy(currentpath,argp);
        currentpath[strlen(currentpath)-10]=0;
        pspDebugScreenInit();
        pspDebugScreenSetBackColor(0x00770000);
        pspDebugScreenClear();

        pspDebugScreenPrintf("\n_|      _|    _|_|    _|_|_|    _|_|_|_|_|  _|    _|  _|_|_|    _|_|_|\n\
_|_|  _|_|  _|    _|  _|    _|      _|      _|    _|    _|    _|      \n\
_|  _|  _|  _|_|_|_|  _|_|_|        _|      _|_|_|_|    _|      _|_|  \n\
_|      _|  _|    _|  _|            _|      _|    _|    _|          _|\n\
_|      _|  _|    _|  _|            _|      _|    _|  _|_|_|  _|_|_|  ");
        pspDebugScreenPrintf("\n\n\n\n");

        pspDebugScreenPrintf("- Loading USB Accessory module...");

        if (moduleLoadStart("usbacc.prx")) {
        	pspDebugScreenSetBackColor(0x00000077);
                pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT LOAD usbacc.prx\nGPS WILL BE DISABLED\n\n\n\n");
		sceKernelDelayThread(4000000);
		goto skipgpsinit;
        }else
                pspDebugScreenPrintf("\t ok\n");

        pspDebugScreenPrintf("- Loading USB GPS module... ");
        if (moduleLoadStart("usbgps.prx"))
        {
        	pspDebugScreenSetBackColor(0x00000077);
                pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT LOAD usbgps.prx\nGPS WILL BE DISABLED\n\n\n\n");
		sceKernelDelayThread(4000000);
		goto skipgpsinit;
        }else
                pspDebugScreenPrintf("\t ok\n");

                // Start usb drivers
                pspDebugScreenPrintf("- Starting USB BUS driver...");
                if (sceUsbStart(PSP_USBBUS_DRIVERNAME,0,0)) {
        		pspDebugScreenSetBackColor(0x00000077);
                	pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT START USB BUS DRIVER\nGPS WILL BE DISABLED\n\n\n\n");
			sceKernelDelayThread(4000000);
			goto skipgpsinit;
                } else
                        pspDebugScreenPrintf("\t\t ok\n");

                pspDebugScreenPrintf("- Starting USB Accessory driver...");
                if (sceUsbStart("USBAccBaseDriver",0,0)) {
        		pspDebugScreenSetBackColor(0x00000077);
                	pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT START USB ACC DRIVER\nGPS WILL BE DISABLED\n\n\n\n");
			sceKernelDelayThread(4000000);
			goto skipgpsinit;
                } else
                        pspDebugScreenPrintf("\tok\n");

                pspDebugScreenPrintf("- Starting USB GPS driver...");
                if (sceUsbStart(PSP_USBGPS_DRIVERNAME,0,0)) {
        		pspDebugScreenSetBackColor(0x00000077);
                	pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT START USB GPS DRIVER\nGPS WILL BE DISABLED\n\n\n\n");
			sceKernelDelayThread(4000000);
			goto skipgpsinit;
                } else
                        pspDebugScreenPrintf("\t\t ok\n");

                // Initialize GPS device
                pspDebugScreenPrintf("- Opening USB GPS device...");
                if (sceUsbGpsOpen()) {
        		pspDebugScreenSetBackColor(0x00000077);
                	pspDebugScreenPrintf("\n\n\n\nERROR:COULD NOT OPEN GPS DEVICE\nGPS WILL BE DISABLED\n\n\n\n");
			sceKernelDelayThread(4000000);
			goto skipgpsinit;
                } else
                        pspDebugScreenPrintf("\t\t  ok\n");

skipgpsinit:
		if (loadwifi) {
			if (sceUtilityLoadNetModule(PSP_NET_MODULE_COMMON) < 0)
{
  fprintf(stdout,"Error, could not load PSP_NET_MODULE_COMMON\n");
  sceKernelSleepThread();
}
if (sceUtilityLoadNetModule(PSP_NET_MODULE_INET) < 0)
{
  fprintf(stdout,"Error, could not load PSP_NET_MODULE_INET\n");
  sceKernelSleepThread();
}
/*
   int err = pspSdkInetInit();
   if (err != 0) {
      fprintf(stdout,"InetInit failed: %i\n", err);
      return -1;
   } */

		}


	ms_write_log("\nmMapThis Started");
        sceRtcGetCurrentTick(&triptime);
        SetupCallbacks();
#else
int main( int argc, char *argv[] )
{

        strcpy(currentpath,argv[0]);
        currentpath[strlen(currentpath)-10]=0; //denis: standalone
	int umid = 0;
        SetupCallbacks();
        umid = sceKernelCreateThread("user_main_thread",user_main, 33, 64*1024, 0, 0);
        if(umid >= 0)
        {
                sceKernelStartThread(umid, 0, 0);
        } else {
		ms_write_log("Could not start main\n");
	}

	status = nmeap_init(&nmea,(void *)&user_data);
        if (status != 0) {
                ms_write_log("nmeap_init %d\n",status);
                exit(1);
        }
   
        status = nmeap_addParser(&nmea,"GPGGA",nmeap_gpgga,gpgga_callout,&gga);
        if (status != 0) {
                ms_write_log("nmeap_add %d\n",status);
                exit(1);
        }

        status = nmeap_addParser(&nmea,"GPRMC",nmeap_gprmc,gprmc_callout,&rmc);
        if (status != 0) {
                ms_write_log("nmeap_add %d\n",status);
                exit(1);
        }

        status = nmeap_addParser(&nmea,"GPGSV",custom_gpgsv,gpgsv_callout,&gsv);
        if (status != 0) {
                ms_write_log("nmeap_add %d\n",status);
                exit(1);
        }

	sceKernelDelayThread(2000000);
	if (loadwifi) {
		pspSdkLoadInetModules();
	}

	sioInit(baud,0);
	int     ch;
        char buffer1[1024];
        int counter=0;
	int timeout=0;
	while (running) {
	if (fakefeed) {
	fp=fopn("gps.txt","r");
	//printf("fakefeed!\n");
	char * s;
	while(running) {
		memset(buffer,0,sizeof(buffer));
		int i=0;
		while (i<2) {
                s=fgets(buffer1,1023,fp);
                while (strncmp(buffer1,"$GPGGA",6)!=0 && strncmp(buffer1,"$GPRMC",6)!=0 && strncmp(buffer1,"$GPGSV",6)!=0 && s!=NULL) {
                        s=fgets(buffer1,1023,fp);
			strcat(buffer,buffer1);
		}
			
                 buffer1[strlen(buffer1)+1]=0;

                //fprintf(stdout,"[%s]\n",buffer1);
		if (strncmp(buffer1,"$GPGSV",6)!=0)
			i++;
                char *pvec =buffer1;
                ch=0;
                while (ch>=0) {
                        if (*pvec == 0)
                                ch = -1;
                        else
                                ch = *pvec++;
                        //printf("%c",ch);
                        status = nmeap_parse(&nmea,ch);
                }
                }
		if (togglefeed==1) {
			togglefeed=0;
			break;
		}
		sceKernelDelayThread(999990);

        }
	fclose(fp); 
	} else {
	while(running) {
                //fprintf(stdout,"%d\n",isconnected);
                ch = sioReadChar();
		if (ch==-1) {
			//fprintf(stdout,".\n");
			if (counter>0 && buffer1[counter-1]=='\n') {
				strcpy(buffer,buffer1);
                               	//fprintf(stdout,"\n[%s]\n",buffer1);
				//if (gpsout!=NULL)
                                	//fprintf(gpsout,"\n[%s]\n",buffer1);
				nmea_filter(buffer1);
				//if (gpsout!=NULL)
                                	//fprintf(gpsout,"\n{%s}\n",buffer1);
				char *pvec =buffer1;
				char tempch=*pvec++;
				timeout=0;
				while (tempch>0) {
					status = nmeap_parse(&nmea,tempch);
        				tempch = *pvec++;
				}
				isconnected=1;
				if (warn[0]!='O') {
					altitude=0;
					speed=0;
					prevlat=0;
					prevlon=0;
				}
// MIB.42 - to record gpsdata to file if record is on
				if (gpsout!=NULL)
					fprintf(gpsout, "%s", buffer1);
// MIB.42 - eof edit
				memset(buffer1,0,sizeof(buffer1));
				counter=0;

			} else {
				timeout++;
				if (timeout>15) {
					isconnected=0;
					memset((void*) &gsv, 0, sizeof(gsv));
					satellites=0;
					ltime=0;
					date=0;
					course1=0;
					prevlat=0;
					prevlon=0;
				}
				if (timeout>150)
					timeout=16;
			}

		}
                if(ch >= 0 && counter <1024) 
                        sprintf(&buffer1[counter++],"%c", ch);
		if (togglefeed==1) {
			togglefeed=0;
			break;
		}
        } 
	}
	}
	sceKernelDelayThread(2000000);
        sceKernelExitGame();

return 0;
}

int user_main (SceSize args, void *argp) {
#endif
	memset(streetbuf,0,sizeof(streetbuf));

	Image * cursor=NULL,  *scale=NULL, *zoomscale=NULL, *arrows=NULL, *compass=NULL, *arrow2mark=NULL, *battery=NULL, *topplate=NULL, *sideplate=NULL, *signalbar=NULL;
	int j;
	char printbuf[64];
	char filename[128];
	char attrbuf1[64];
	char attrbuf2[64];
	char path[128];
	int tx,ty, tyfix, tmpx,tmpy, timer, atimer, alerttimer, duration=0;
	int	startupmaploaded=0;
	double	movement_speed_factor=1.0;	// MIB.42 - to be able to increase "scroll speed" like 2x
	double plat_min,plat_sec,plon_min,plon_sec;
	char speedlabel[16]="SPEED"; translate(speedlabel);
	char bearinglabel[16]="BEARING"; translate(bearinglabel);
	char altitudelabel[16]="ALTITUDE"; translate(altitudelabel);
	char triptimelabel[16]="TRIPTIME"; translate(triptimelabel);
	char distancelabel[16]="DISTANCE"; translate(distancelabel);
	char avgspeedlabel[16]="AVG SPD"; translate(avgspeedlabel);
	char tomarklabel[16]="TO MARK"; translate(tomarklabel);

	readConfig();
	scePowerSetClockFrequency(startupfrequency,startupfrequency,startupfrequency/2);
	int counter=0;


	initGraphics();
	font_init() ;
//	splashscreen();
	initLatLon();


	//Coord c,xy;
	rotimage=createImage(512,512);
	int firstpass=1;
	int skipmenu;
	sceRtcGetCurrentTick(&triptime);

	while (1) {
	skipmenu=0;
	topmenu:
	marker=0;
	initPath();
	readMapListings(); 
	if (firstpass==1) {
		firstpass=0;
		int i;
		for ( i=0; i<optcount;i++) {
			//fprintf(stdout," [%s] :: [%s]\n", options[i], startupmap);
			if (strcmp(options[i],startupmap)==0) {
				sprintf(zipfile,"./maps/%s",options[i]);
				skipmenu=1;
// MIB.42 - to delay		gpsOn=1;
				startupmaploaded=1;	// MIB.42 - to have smoother init if map is pre-specified
// MIB.42 - eof edit
				//rotatemap=1;
				break;
			}
		
		}

	}
	qsort( options, (optcount-((loadwifi>0)?(1):(0))),sizeof(options[0]),opt_cmp);	// MIB.42 - To avoid == WIFI MAP UPLOAD == to be put in the beginning...
	if (skipmenu==0) {
	Image * background=ldImage("system/background.png");
	blitAlphaImageToScreen(0,0,PSP_WIDTH,PSP_HEIGHT,background,0,0);
	char label[64]="::: SELECT MAP :::"; translate(label);
        int filenum =display_menu(label, options, optcount, 0 ) ;
	beep();
	if (filenum<0) {
		if (filenum<=-100000)
			break;
		else
		filenum=-filenum-1;
	}
	//fprintf(stdout,"[%s]\n",options[filenum]);
	if (strcmp(options[filenum],"===_WIFI_MAP_UPLOAD_===")==0) {
		if (loadwifi)
			map_upload_menu();
		goto topmenu;
	}
	if (background!=NULL)
		freeImage(background);
	sprintf(zipfile,"./maps/%s",options[filenum]);
	gpsOn=0;
	rotatemap=0;
	}


	strcpy(attr_file,"_NONE");
	memset(attr_ifile,0,sizeof(attr_ifile));


        display_message("","PLEASE WAIT WHILE MAP IS LOADING","",0);

	if (gpsfsOpen(zipfile)>0)
		datatype=1; //gpsfs 
	else
		datatype=0;



	TILE_NUM=detect_size(zipfile);
	if (TILE_NUM==1)
        	display_message("MAP SIZE SEEMS TO BE VERY SMALL!","CONSIDER RE-BUILDING THIS MAP.","PRESS [X] TO PROCEED..",30000);
	load_coords(zipfile);

	maxzoom=zoom=get_zoom(TILE_NUM);
	if (load_mapp_prefs()==-1){
		mapx = TILE_SIZE*TILE_NUM/2;
		mapy=mapx;
	}
        else
        {
                if(mapy<0 || mapy>TILE_SIZE*TILE_NUM)
                        mapy=(long)((TILE_SIZE*TILE_NUM)/2);
                if(mapx<0 || mapx>TILE_SIZE*TILE_NUM)
                        mapx=(long)((TILE_SIZE*TILE_NUM)/2);
        }
	zm = powerOf(zoom-1);
	oldy=oldx=mapx;

	idle=0;


	if (firsttime==1) {
#ifndef GENERIC
        thid_gpsmngr = sceKernelCreateThread("gps_manager_thread",gpsmngr, 32, 4096, 0, 0);
        if(thid_gpsmngr >= 0) {
                sceKernelStartThread(thid_gpsmngr, 0, 0);
        }
	else 
                ms_write_log("Failed to start gps_manager_thread!\n");
#endif

	
        thid_cachemngr = sceKernelCreateThread("cachemngr_thread", cachemngr, 34, 8192, 0, 0);
	ms_write_log("id=%d\n",thid_cachemngr);
        if(thid_cachemngr >= 0)
        {
                sceKernelStartThread(thid_cachemngr, 0, 0);
        }
	else   
                ms_write_log("Failed to start cachemngr_thread!\n");

	sceKernelDelayThread(500000);

        thid_garbagecoll = sceKernelCreateThread("garbage_collector_thread",garbage_collector, 35, 1024, 0, 0);
        if(thid_garbagecoll >= 0)
        {
                sceKernelStartThread(thid_garbagecoll, 0, 0);
        }
	else  
                ms_write_log("Failed to start garbage_collector_thread!\n");

	cursor = ldImage("system/cursor.png");
	arrows = ldImage("system/arrows.png");
	compass = ldImage("system/compass.png");
	arrow2mark = ldImage("system/arrow2mark.png");
	blank = ldImage("system/blank.png");
	scale = ldImage("system/scale.png");
	battery = ldImage("system/battery.png");
	topplate = ldImage("system/topplate.png");
	messageplate = ldImage("system/messageplate.png");
	sideplate = ldImage("system/sideplate.png");
	signalbar = ldImage("system/signalbar.png");
	zoomscale = ldImage("system/zoomscale.png");

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(1);
	firsttime=0;
	}

	timer=0;
	atimer=0;
	alerttimer=50;
	while (!((cpad.Buttons & PSP_CTRL_SELECT) && timer>10/(333/Clock))) {
	timer++;
	atimer++;
	if (timer>100) timer=21;
	if (atimer>100) atimer=21;
	if (alerttimer>100) alerttimer=51;

	 sceCtrlPeekBufferPositive(&cpad, 1); 
	if(!(cpad.Buttons &  PSP_CTRL_HOLD))    // MIB.42_2 to make sure no control is entered while we are in "HOLD" position
        {
	int step=2;
 	 if (cpad.Ly <= 0x30)  {
		if (rotatemap==0) {course=0; step=0;}
                gpsOn=0;
                atimer=0;
                my=mapy-round(zm*(2+step)*cos(course*0.0174532925)*movement_speed_factor);		// MIB.42 - variable map scroll speed
                mx=mapx-round(zm*(2+step)*sin((course+180)*0.0174532925)*movement_speed_factor);		// MIB.42 - variable map scroll speed

                if (my>0 && my<TILE_SIZE*TILE_NUM)
                        mapy=(long)my;
                if (mx>0 && mx<TILE_SIZE*TILE_NUM)
                        mapx=(long)mx;
        }
        if (cpad.Ly >= 0xD0) {
		if (rotatemap==0) {course=0; step=0;}
                gpsOn=0;
                atimer=0;
                my=mapy+round(zm*(2+step)*cos(course*0.0174532925)*movement_speed_factor);		// MIB.42 - variable map scroll speed
                mx=mapx+round(zm*(2+step)*sin((course+180)*0.0174532925)*movement_speed_factor);

                if (my>0 && my<TILE_SIZE*TILE_NUM)
                        mapy=(long)my;
                if (mx>0 && mx<TILE_SIZE*TILE_NUM)
                        mapx=(long)mx;
        }
        if (cpad.Lx <= 0x30) {
		if (rotatemap==0) {course=0; step=0;}
                gpsOn=0;
                atimer=0;
                mx=mapx-round(zm*(2+step)*cos(-course*0.0174532925)*movement_speed_factor);		// MIB.42 - variable map scroll speed
                my=mapy-round(zm*(2+step)*sin((-course+180)*0.0174532925)*movement_speed_factor);	// MIB.42 - variable map scroll speed
                if (my>0 && my<TILE_SIZE*TILE_NUM)
                        mapy=(long)my;
                if (mx>0 && mx<TILE_SIZE*TILE_NUM)
                        mapx=(long)mx;
        }
        if (cpad.Lx >= 0xD0) {
		if (rotatemap==0) {course=0; step=0;}
                gpsOn=0;
                atimer=0;
                mx=mapx+round(zm*(2+step)*cos(-course*0.0174532925)*movement_speed_factor);		// MIB.42 - variable map scroll speed
                my=mapy+round(zm*(2+step)*sin((-course+180)*0.0174532925)*movement_speed_factor);	// MIB.42 - variable map scroll speed
                if (my>0 && my<TILE_SIZE*TILE_NUM)
                        mapy=(long)my;
                if (mx>0 && mx<TILE_SIZE*TILE_NUM)
                        mapx=(long)mx;
         }
	}       // MIB.42_2 
	if ((cpad.Buttons &  PSP_CTRL_CROSS) && timer>10/(333/Clock)) {
		timer=0;
		if(marker)
		{
			marker=0;
			initPath();
	        	display_message("","MARKER OFF","",800);
		}
		else
		{
			marker=1;
			lat1=c.lat;
			lon1=c.lon;
			mapx1=mapx;
			mapy1=mapy;
			if (attraction[0]==NULL)
				attraction[0] = ldImage("system/icons/attraction.png");
	        	display_message("","MARKER SET","",800);
		}
	}

	// MIB.42_5     Special for recording thread statuses
        if ((cpad.Buttons &  PSP_CTRL_LTRIGGER) && (cpad.Buttons &  PSP_CTRL_RTRIGGER) && timer>10/(333/Clock))
        {
                ms_write_log("\nThread Infos : thid_cachemngr=%d, thid_garbagecoll=%d, thid_usermain=%d thid_wifi=%d\n",thid_cachemngr,thid_garbagecoll,thid_usermain,thid_wifi);
                record_thread_info(thid_cachemngr);
                record_thread_info(thid_garbagecoll);
                record_thread_info(thid_usermain);
                record_thread_info(thid_wifi);
                timer=0;
        }
        else
        {

	if ((cpad.Buttons &  PSP_CTRL_LTRIGGER) && timer>10/(333/Clock) && rotatemap>0) {
                course+=2;
                if (course>=360)
                        course-=360;

        }
        if ((cpad.Buttons &  PSP_CTRL_RTRIGGER) && timer>10/(333/Clock) && rotatemap>0) {
                course-=2;
                if (course<0)
                        course+=360;

        }
	}

	if (((cpad.Buttons &  PSP_CTRL_SQUARE)||(startupmaploaded)) && timer>10/(333/Clock)) {	// MIB.42 - to accomodate map preload functionality
		startupmaploaded=0;	// MIB.42 - only first pass
		timer=0;
		gpsOn=1;
		strcpy(warn,"BAD");
		mx=(double)mapx;
		my=(double)mapy;
		deltax=0;
		deltay=0;
	        display_message("G P S   M O D E","","ON",400);
		//sceRtcGetCurrentTick(&triptime);
		//distance=0.00;
	}



	if ((cpad.Buttons &   PSP_CTRL_START) && timer>10/(333/Clock)) {
		timer=0;

        	int selected=display_icons_menu( 5 ) ;
		switch (selected) {
			case 0:
				add_poi_menu();
				break;
			case 1:
				beep();
				readAttractionsListings();
				if (optcount==0)
					strcpy(options[optcount++],"_NONE");
				qsort( options, optcount,sizeof(options[0]),opt_cmp);
				int fn=display_menu("::: SELECT ATTRACTION TYPE :::",  options , optcount, 0 ); 
				if (fn!=-100000) {
					if (fn < 0 ) {
						
						fn=-fn-1;
						if (strcmp(options[fn],"_NONE")!=0)
							search_poi_menu(options[fn]);

				} else {

					strcpy(attr_file,options[fn]);
					turn_off_attractions();
					flipScreen();
		       			display_message("","LOADING DATA","",0);
					if (attr_file!=NULL && strcmp(attr_file,"_NONE")!=0) {
						int attr_counter=load_attractions("_MY_POIS", zipfile, datatype,  mapx,  mapy, zoom, "");
				 		attr_counter=load_attractions(attr_file, zipfile, datatype,  mapx,  mapy, zoom, "");
					int k;
					for (k=0;k<=get_image_count(); k++) {
					//fprintf(stdout,"%d---->[%s]\n",get_image_count(),attr_ifile[k]);
					if (strlen(attr_ifile[k])==0)
       	                		 	attraction[k] = ldImage("system/icons/attraction.png");
       		      		   	else {
                              		  char filename1[128];
                     		           sprintf(filename1,"%s/%s", zipfile,attr_ifile[k]);
					if (my_access(filename1, F_OK) != 0)
                               			sprintf(filename1,"system/icons/%s", attr_ifile[k]);
					if (my_access(filename1, F_OK) != 0)
                               			sprintf(filename1,"system/icons/attraction.png");
                     		           attraction[k]=ldImage(filename1);
              		  		}
				}

				attr_flag=1;
				} else {
	       				display_message("WARNING!","NO ATTRACTION","TYPE SELECTED ",1000);
				}
				}
			}

			break;
			case 2:
				locate_address();
				break;
			case 3:
			sprintf(path,"%s/geodata.dat",zipfile);
			FILE * test = fopn( path,"r");
			if (test==NULL)
				test = fopn( "geodata.dat","r");
			if (test==NULL) {
				display_message("ERROR!","GEODATA FILE","IS MISSING!",1000);

			} else {
				fclose(test);
				flipScreen(); 
       				display_message("LOOKING FOR","NEAREST","ADDRESS LOCATIONS",0);
				memset(streetbuf,0,sizeof(streetbuf));
				reverse_lookup(c.lat, c.lon, streetbuf, zipfile);
				displaycounter=0;
				streetbuf[99]=0;
			}
			break;
			case 5:
				flipScreen(); 
				if (Clock==333) {
                        		Clock=222;
                        		display_message("","CHANGING CLOCK TO 222MHZ","",700);
                        		scePowerSetClockFrequency(Clock,Clock,Clock/2);
			} else {
                        	Clock=333;
                        	scePowerSetClockFrequency(Clock,Clock,Clock/2);
                        	display_message("","CHANGING CLOCK TO 333MHZ","",700);
			}
			break;
			case 6:
				if (showpanels==1) {
					showpanels=0;
                        		display_message("","HIDING THE DATA PANELS","",600);
				} else {
					showpanels=1;
                        		display_message("","SHOWING THE DATA PANELS","",600);
				}
			break;
			case 8:
                                gps_info();
                                break;
                        case 9:
                                distance=0;
                                avgspeed=0;
				prevlat=0;
				prevlon=0;
                                sceRtcGetCurrentTick(&triptime);
                                break;
                        case 4:
				if (fakefeed==1)  {
					fakefeed=0;
					togglefeed=1;
                        		display_message("","READING THE DATA FROM GPS UNIT","",600);
				}else{
					fakefeed=1;
					if (gpsout!=NULL) {
						fclose(gpsout);
						gpsout=NULL;
					}
					togglefeed=1;
                        		display_message("","READING THE GPS DATA FROM FILE","",600);
				}
                                break;
// MIB.42 - TAKE SCREENSHOT
			case 7 :
				{
					char filename2[256];
					time_t		ptime;
					struct tm	*MT;
					timer=0;
					ptime=time(NULL);
					MT=localtime(&ptime);
					sprintf(filename2,"ms0:/PSP/PHOTO/Lat_%8.4f__Lon_%8.4f__%02d%02d_%02d%02d%02d.png",c.lat,c.lon,MT->tm_mday,(MT->tm_mon)+1,MT->tm_hour,MT->tm_min,MT->tm_sec);
					savePngImage(filename2,getVramDisplayBuffer(),SCREEN_WIDTH,SCREEN_HEIGHT,PSP_LINE_SIZE,0);
				}
				break;
// MIB.42 - eof edit
                        case 11:
		//		MP3_PlaySnipet("ms0:/MUSIC/SNIPET.mp3");		// MIB.42_7
                               configuration();
                                break;
                        case 10:
/*
// MIB.42_7
#ifndef GENERIC
				sprintf(dirname,"%s/PLAYLIST.M3U",currentpath);		// hijacking 'dirname'
				MP3_ProcessM3U(dirname);
#else
				MP3_ProcessM3U("PLAYLIST.M3U");
#endif
*/

				helpscreen();

                                break;

		}
	}

	if ((cpad.Buttons & PSP_CTRL_CROSS) && timer>10/(333/Clock) ) {
		timer=0;
		if (fakefeed==1 && gpsOn==1) {
			ffreadspeed+=2;
			if (ffreadspeed>10)
				ffreadspeed=1;
		} 
		
	}
	if ((cpad.Buttons &  PSP_CTRL_TRIANGLE) && timer>10/(333/Clock)) {
		timer=0;
		beep();

		if (attr_flag==1) {
			turn_off_attractions();
	        	display_message("","POI OFF","",800);
		} else {
	       	display_message("","LOADING DATA","",0);
		if (attr_file!=NULL && strcmp(attr_file,"_NONE")!=0) 
			turn_on_attractions();
		else {
	       		display_message("WARNING!","NO ATTRACTION","TYPE SELECTED ",1000);
		}
		}
	}
	//toggle  gps nmea to file dump


// MIB.42 - changed this to accomodate selecting variable map scroll speed ( if gpsOn==0 only )

	if ((cpad.Buttons & PSP_CTRL_LEFT) && timer>10/(333/Clock))
	{
		if(gpsOn)
		{
			if(!fakefeed) {
				beep();
				timer=0;
				if (gpsout!=NULL) {
		       			display_message("GPS DATA","","RECORDING OFF",400);
					fclose(gpsout);
					gpsout=NULL;
				} else {
					gpsout=fopn("gps.txt", "w");
		       			display_message("GPS DATA","","RECORDING ON",400);
				}
			}
		}
		else
		{
			movement_speed_factor=2.0;	// MIB.42 - variable map scroll speed
		}
	}
	else
		movement_speed_factor=1.0;
// MIB.42 - eof edit


	if ((cpad.Buttons &   PSP_CTRL_RIGHT) && timer>10/(333/Clock) ) {
			beep();
			timer=0;
			if (rotatemap==2) {
	       			display_message("SWITCHING TO","","NORTH UP MODE",400);
				if (nightmode==0)
					nightmode=1;
				else
					nightmode=0;
				
				while (tlock==1) 
					sceKernelDelayThread(1);
				tlock=1;
				unload_group(4096,zipfile,datatype);
				tlock=0;
				rotatemap=0;
			//	course=0;
			} else if (rotatemap==1) {
	       			display_message("SWITCHING TO","","3D MODE",400);
				rotatemap=2;
			} else {
				rotatemap=1;
	       			display_message("SWITCHING TO","","TRACK UP MODE",400);
			}

	}
	if ((cpad.Buttons &   PSP_CTRL_DOWN) && timer>10/(333/Clock)) {
		if (zm<TILE_NUM/2) {
			beep();
			timer=0;
			atimer=-10;
			zoom++;
			zm = powerOf(zoom-1);
		}
  	}

	if ((cpad.Buttons &  PSP_CTRL_UP) && timer>10/(333/Clock)) {
		if (zoom>1) {
			beep();
			timer=0;
			atimer=-10;
			zoom--;
			zm = powerOf(zoom-1);
		}

  	}


	tx=  (mapx/zm - PSP_WIDTH/2 - TILE_SIZE)/TILE_SIZE*TILE_SIZE;
	ty=  (mapy/zm - PSP_HEIGHT/2 - TILE_SIZE)/TILE_SIZE*TILE_SIZE;

	if (mapx/zm>TILE_SIZE*TILE_NUM/zm-PSP_WIDTH/2)
		tx-=TILE_SIZE;
	if (mapy/zm>TILE_SIZE*TILE_NUM/zm-PSP_HEIGHT/2)
		ty-=TILE_SIZE;

		tyfix=ty;
		while (tlock==1) 
			sceKernelDelayThread(1);
		tlock=1;
	while (tx < mapx/zm + PSP_WIDTH) {
		ty=tyfix;
		while (ty < mapy/zm + PSP_HEIGHT) {
			sceKernelDelayThread(1);
			if (datatype==1)
					sprintf(filename,"%dx%04d%04d.GPS", zm, (int)ty/TILE_SIZE, (int) tx/TILE_SIZE);
			else
				sprintf(filename,"%s/%dx/%03d/%dx%03d%03d.%s",zipfile,zm, (int) ty/TILE_SIZE, zm, (int)ty/TILE_SIZE, (int) tx/TILE_SIZE,filetype);
			current=loadfromcache(filename);
			tmpx=tx-mapx/zm+PSP_WIDTH/2;
			tmpy=ty-mapy/zm+PSP_HEIGHT/2;
		
			if (rotatemap==0) {
			if (current!=NULL)
				blitAlphaImageToScreen(0,0,TILE_SIZE,TILE_SIZE,current,tmpx,tmpy);
			else {
				blitAlphaImageToScreen(0,0,256,256,blank,tmpx,tmpy);
				sceKernelDelayThread(5);
			}
			} else {
		//	fprintf(stdout,"%3d:%3d\n",tmpx, tmpy);

			if (current!=NULL)
				blitImageToImage(0,0,TILE_SIZE,TILE_SIZE,current,tmpx+16,tmpy+120,rotimage);
			else {
				int ix,iy;
				for (ix=0; ix<4; ix++) {
					for (iy=0; iy<4; iy++) {
						blitImageToImage(0,0,64,64,blank,tmpx+16+ix*64,tmpy+120+iy*64,rotimage);
					}
				}

				sceKernelDelayThread(5);
			}
			}

			ty+=TILE_SIZE;
				
		}
		tx+=TILE_SIZE;
	}
	tlock=0;

	counter++;
		c=getGPS(mapx,mapy);

	if (marker)
		readPath();

	if (attr_flag && waypoint && gpsOn) {
        	u64 newTick;
        	sceRtcGetCurrentTick(&newTick);
        	if (newTick-routeTick>600*1000000) { //check route every 10 min
			turn_off_attractions();
			turn_on_attractions();
			routeTick=newTick;
		}

	}

	//display attractions....
	memset(attrbuf1,0,sizeof(attrbuf1));
	memset(attrbuf2,0,sizeof(attrbuf2));
	if (strlen(streetbuf)>0) {
		displaycounter++;
		streetbuf[39]=0;
		strcpy(attrbuf1,streetbuf);
		strcpy(attrbuf2,&streetbuf[40]);
		if (displaycounter>320) {
			memset(streetbuf,0,128);
			displaycounter=0;
		}
	}
	
	if (attr_flag==1 && atimer>3/(333/Clock) ) {  
		if (rotatemap==0) {
		for (j=attractions_count()-1; j>=0; j--) {
			if (attractions[j]!=NULL && abs(attractions[j]->x-mapx)<PSP_WIDTH*zm && abs(attractions[j]->y-mapy) < PSP_HEIGHT*zm){
				if (attraction[attractions[j]->i]==NULL)
					continue;

				attr_width=attraction[attractions[j]->i]->imageWidth;
				attr_height=attraction[attractions[j]->i]->imageHeight;
			if (attractions[j]!=NULL && abs(attractions[j]->x-mapx)<PSP_WIDTH*zm && abs(attractions[j]->y-mapy) < PSP_HEIGHT*zm){
				blitAlphaImageToScreen(attr_width/2,0,attr_width/2,attr_height,attraction[attractions[j]->i],(attractions[j]->x/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2,(attractions[j]->y/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2);
				if (abs(attractions[j]->x/zm-mapx/zm)<attr_width/4+attractions[j]->waypoint*warn_dist/zm && abs(attractions[j]->y/zm-mapy/zm) < attr_height/2+attractions[j]->waypoint*warn_dist/zm) {
					if (attractions[j]->waypoint ) { 
						if (attrbuf2[0]==0 || strncmp(attrbuf2,"MIDPOINT",8)==0) {
							memset(attrbuf1,0,sizeof(attrbuf1));
							memset(attrbuf2,0,sizeof(attrbuf2));
							sprintf(attrbuf1,"%s",attractions[j]->name); 
						sprintf(attrbuf2,"%s",attractions[j]->details);  	
					}
					} else {	
						sprintf(attrbuf1,"POI: %s",attractions[j]->name); 
						sprintf(attrbuf2,"%s",attractions[j]->details); 
					}
				if (attraction[attractions[j]->i]==NULL)
					continue;
					play_alert(attractions[j]->message);
					if (duration==0)
						attractions[j]->message=0;
					attr_width=attraction[attractions[j]->i]->imageWidth;
					attr_height=attraction[attractions[j]->i]->imageHeight;
					blitAlphaImageToScreen(0,0,attr_width/2,attr_height,attraction[attractions[j]->i],(attractions[j]->x/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2,(attractions[j]->y/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2);
				}
			}
		}
	}
	} else {
		for (j=attractions_count()-1; j>=0; j--) {
			if (attractions[j]!=NULL && abs(attractions[j]->x-mapx)<PSP_WIDTH*zm && abs(attractions[j]->y-mapy) < PSP_HEIGHT*zm){
					attr_width=attraction[attractions[j]->i]->imageWidth;
					attr_height=attraction[attractions[j]->i]->imageHeight;
					blitImageToImage(attr_width/2,0,attr_width/2,attr_height,attraction[attractions[j]->i],(attractions[j]->x/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2+16,(attractions[j]->y/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2+120,rotimage);
				if (abs(attractions[j]->x/zm-mapx/zm)<attr_width/4+attractions[j]->waypoint*warn_dist/zm && abs(attractions[j]->y/zm-mapy/zm) < attr_height/2+attractions[j]->waypoint*warn_dist/zm) {
					if (attractions[j]->waypoint) { 
						if (attrbuf2[0]==0 || strncmp(attrbuf2,"MIDPOINT",8)==0) {
							memset(attrbuf1,0,sizeof(attrbuf1));
							memset(attrbuf2,0,sizeof(attrbuf2));
						sprintf(attrbuf1,"%s",attractions[j]->name); 
						sprintf(attrbuf2,"%s",attractions[j]->details);  	
					}
					} else {	
						sprintf(attrbuf1,"POI: %s",attractions[j]->name); 
						sprintf(attrbuf2,"%s",attractions[j]->details); 
					}
					play_alert(attractions[j]->message);
					if (duration==0)
						attractions[j]->message=0;
					attr_width=attraction[attractions[j]->i]->imageWidth;
					attr_height=attraction[attractions[j]->i]->imageHeight;
					blitImageToImage(0,0,attr_width/2,attr_height,attraction[attractions[j]->i],(attractions[j]->x/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2+16,(attractions[j]->y/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2+120,rotimage);
				}
			}
		}


	}
	}

		if (marker && rotatemap==0) { 
			drawLineScreen((mapx1/zm-4-mapx/zm)+PSP_WIDTH/2+4,(mapy1/zm-4-mapy/zm+4)+PSP_HEIGHT/2,PSP_WIDTH/2,PSP_HEIGHT/2,0x88888888);
		int i;
		Color c=0xff0000ff;
		if (nightmode)
			c=0xff00ff00;
		for ( i=1; i<pathcounter-1; i++) {
			drawLineScreen((pathx[i]/zm-4-mapx/zm)+PSP_WIDTH/2+4,(pathy[i]/zm-4-mapy/zm)+PSP_HEIGHT/2+4,(pathx[i+1]/zm-4-mapx/zm)+PSP_WIDTH/2+4,(pathy[i+1]/zm-4-mapy/zm)+PSP_HEIGHT/2+4,c);
		}
		} else if (rotatemap>0) {
			if (marker)
				drawLineImage((mapx1/zm-4-mapx/zm)+PSP_WIDTH/2+4+16,(mapy1/zm-4-mapy/zm+4)+PSP_HEIGHT/2+120,PSP_WIDTH/2+16,PSP_HEIGHT/2+120,0x88888888,rotimage);
		int i;
		Color c=0xff0000ff;
		if (nightmode)
			c=0xff00ff00;
		for ( i=1; i<pathcounter-1; i++) {
			drawLineImage((pathx[i]/zm-4-mapx/zm)+PSP_WIDTH/2+20,(pathy[i]/zm-4-mapy/zm)+PSP_HEIGHT/2+124,(pathx[i+1]/zm-4-mapx/zm)+PSP_WIDTH/2+20,(pathy[i+1]/zm-4-mapy/zm)+PSP_HEIGHT/2+124,c, rotimage);
		}



		}
	if ( marker && abs(mapx1-mapx)<PSP_WIDTH*zm && abs(mapy1-mapy) < PSP_HEIGHT*zm){
		attr_width=attraction[0]->imageWidth;
		attr_height=attraction[0]->imageHeight;
		if (rotatemap==0) { 
			blitAlphaImageToScreen(0,0,attr_width/2,attr_height,attraction[0],(mapx1/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2,(mapy1/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2);

		}else { 
			blitImageToImage(0,0,attr_width/2,attr_height,attraction[0],(mapx1/zm-attr_width/4-mapx/zm)+PSP_WIDTH/2+16,(mapy1/zm-attr_height/2-mapy/zm)+PSP_HEIGHT/2+120,rotimage);
		}

	}


	if (rotatemap==1) 
		rotate512img(rotimage,(180+course)*0.0174532925);
	else if (rotatemap==2)
                threeD512img(rotimage,(180+course)*0.0174532925);
		
	//nightMode();
	if (gpsOn) {
			
			double hdopflag= 30*hdop/(powerOf(basezoom+zoom+2));
                                if (rotatemap>0) {
				if (hdopflag>=15 && hdopflag<80) {
					if (rotatemap==1)
						drawCircleScreen(240,136,hdopflag,0xff0000ff);
					else 
						if (hdopflag>=30)
							drawElipseScreen(240,140,hdopflag*2,0xff0000ff);
					
				}
                        if (warn[0]=='O') {
				if (rotatemap==2)
                                	blitAlphaImageToScreen(0,25,50,35,arrows,215,116);	
				else
                                	blitAlphaImageToScreen(0,0,25,25,arrows,228,124);
                        }else {
				if (rotatemap==2)
                                	blitAlphaImageToScreen(50,25,50,35,arrows,215,116);	
				else
                                	blitAlphaImageToScreen(0,0,23,23,cursor,228,124);
			}
			if (rotatemap==1)
                        	blitAlphaImageToScreen((((int)course+22)%360/45)*38,0,38,38,compass,360+(1-showpanels)*80,2);
			else
                        	blitAlphaImageToScreen((((int)course+22)%360/45)*38,38,38,26,compass,360+(1-showpanels)*80,2);
                } else {
                        if (warn[0]=='O') {
				if (hdopflag>15 && hdopflag<80)
					drawCircleScreen(240,136,hdopflag,0xff0000ff);
                                blitAlphaImageToScreen((((int)course+22)%360/45)*25,0,25,25,arrows,228,124);
                        } else
                                blitAlphaImageToScreen(0,0,23,23,cursor,228,124);
				
                }
        } else {
                if (marker) {
                        if (speedfix>1.8)
                                sprintf(printbuf,"[%.2f]", pathdist/1000);
                        else
                                sprintf(printbuf,"[%.2f]", pathdist/1609.344);
                        draw_string (printbuf, 220,114);
                }
		if (rotatemap<2)
                	blitAlphaImageToScreen(0,0,23,23,cursor,228,124);
		else
                	blitAlphaImageToScreen(50,25,50,35,arrows,215,116);	
                if (rotatemap==1)
                        blitAlphaImageToScreen((((int)course+22)%360/45)*38,0,38,38,compass,440,2);
                if (rotatemap==2)
                        blitAlphaImageToScreen((((int)course+22)%360/45)*38,38,38,26,compass,440,2);
		}


	if ((ftx>=0 || fty>=0) && rotatemap<2)
		blitAlphaImageToScreen(0,(zoom+basezoom+1)*30,123,30,scale,5,PSP_HEIGHT-35);
	draw_zoom_scale(5,20,zoomscale,zoom, maxzoom);
	if (showpanels) {
	if (gpsOn!=1){
		blitAlphaImageToScreen(0,0,14,16,topplate,0,0);
		blitAlphaImageToScreen(96,0,14,16,topplate,14,0);
		if (scePowerGetBatteryLifePercent()<=100 && scePowerGetBatteryLifePercent()>0)
			blitAlphaImageToScreen(((100-scePowerGetBatteryLifePercent())/25)*16,0,16,10,battery,5,3);
		else
			blitAlphaImageToScreen(0,0,16,10,battery,5,3);
	if (ftx>=0 || fty>=0) {
		double plat= c.lat;
		double plon= c.lon;
		char NS='N';
		char EW='E';
		if (plat<0) {
			plat*=-1;
			NS='S';
		} else if (plat==0)
			NS=' ';
		if (plon<0) {
			plon*=-1;
			EW='W';
		}else if (plon==0)
			EW=' ';

		switch(dms)
                {
                        case 1 :
                                sprintf(printbuf,"%c%3.0f\260%02.3f'  %c%3.0f\260%02.3f'",  NS, floor(plat), 60*(plat-floor(plat)), EW, floor(plon), 60*(plon-floor(plon)));
                        break;
                        case 2 :                                // \260=0xBO(degree) \042=0x22=" \047=0x27='
                                plat_min=60*(plat-floor(plat));
                                plat_sec=59*(plat_min-floor(plat_min));
                                plon_min=60*(plon-floor(plon));
                                plon_sec=59*(plon_min-floor(plon_min));
                                sprintf(printbuf,"%c%3.0f\260%02.0f\047%02.0f\042   %c%3.0f\260%02.0f\047%02.0f\042",  NS, floor(plat), floor(plat_min), plat_sec, EW, floor(plon), floor(plon_min), plon_sec);
                        break;
                        default :
                                sprintf(printbuf,"%c%10.6f\260  %c%10.6f\260", NS,plat, EW,plon);
                        break;
                }
		blitAlphaImageToScreen(0,0,110,16,topplate,28,0);
		blitAlphaImageToScreen(0,0,110,16,topplate,138,0);
		draw_string (printbuf, 38,4);
		if (marker){
			double range=0;
			double bearing=0;
			GeoRangeAndBearing(c.lat, c.lon, lat1,lon1, &range, &bearing) ;
			if (speedfix>1.8) //kilometers
				sprintf(printbuf,"DIST:%6.2f", range/1000);
			else //miles
				sprintf(printbuf,"DIST:%6.2f", range/1609.344);
			blitAlphaImageToScreen(0,0,110,16,topplate,248,0);
			draw_string (printbuf, 256,4);

		}

	}
	}
	if (gpsOn) {
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,0);
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,34);
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,68);
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,102);
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,136);
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,170);
		draw_string (speedlabel ,408,4);
		sprintf(printbuf,"%4.1f",speed*speedfix);
		draw_big_string(printbuf,416,15);

		draw_string (bearinglabel ,408,38);
		if (warn[0]=='B')
			sprintf(printbuf,"  -- ");
		else
			sprintf(printbuf,"  %2s ",heading[((int)course+22)%360/45]);
		draw_big_string(printbuf,416,47);
		draw_string (altitudelabel ,408,72);
		if (warn[0]=='B')
			sprintf(printbuf,"  --");
		else
			sprintf(printbuf," %4.1f",altitude*altfix);
		draw_big_string(printbuf,416,83);
		draw_string (triptimelabel ,408,106);
		u64 curTick;
		sceRtcGetCurrentTick(&curTick);
		curTick=(curTick-triptime)/1000000;
		sprintf(printbuf,"%2d:%02d",(int)curTick/60, (int)curTick%60);
		draw_big_string(printbuf,416,117);

		draw_string (distancelabel ,408,140);
		sprintf(printbuf,"%4.1f",speedfix*distance*0.53986935161690870809264158073746/1000);
		draw_big_string(printbuf,416,151);

		draw_string (avgspeedlabel ,408,174);
		sprintf(printbuf,"%4.1f",avgspeed);
		draw_big_string(printbuf,416,185);
		if (attrbuf1[0]==0) {
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,204);
		if (marker) {
			draw_string (tomarklabel ,408,208);
			double range=0;
			double bearing=0;
			GeoRangeAndBearing(c.lat, c.lon, lat1,lon1, &range, &bearing) ;
			if (speedfix>1.8) //kilometers
				sprintf(printbuf,"%4.1f",range/1000);
			else //miles
				sprintf(printbuf,"%4.1f",range/1609.344);
			draw_big_string(printbuf,410,217);
			if (rotatemap>0) 
				blitAlphaImageToScreen((((int)(bearing-course+360+22)%360)/45)*20,0,20,20,arrow2mark,458,215);
			else
				blitAlphaImageToScreen((((int)bearing+22)%360/45)*20,0,20,20,arrow2mark,458,215);

		} else {
			double plat= c.lat;
			double plon= c.lon;
			char NS='N';
			char EW='E';
			if (plat<0) {
				plat*=-1;
				NS='S';
			} else if (plat==0)
				NS=' ';
			if (plon<0) {
				plon*=-1;
				EW='W';
			}else if (plon==0)
				EW=' ';
			 switch(dms)
                	{
                        case 1 :
                                sprintf(printbuf,"%c%3.0f\260%2.2f", NS, floor(plat), 60*(plat-floor(plat)));
                        break;
                        case 2 :                                // \260 (degree) \042=0x22=" \047=0x27='
                                //double plat_min,plat_sec;
                                plat_min=60*(plat-floor(plat));
                                plat_sec=60*(plat_min-floor(plat_min));
                                sprintf(printbuf,"%c%3.0f\260%02.0f\047%02.0f\042",  NS, floor(plat), floor(plat_min), plat_sec);
                        break;
                        default :
                                sprintf(printbuf,"%c%8.4f", NS,plat);
                        break;
                	}

			draw_string (printbuf ,404,212);
			switch(dms)
                	{
                        case 1 :
                                sprintf(printbuf,"%c%3.0f\260%2.2f", EW, floor(plon), 60*(plon-floor(plon)));
                        break;
                        case 2 :                                // \260 degrees \042=0x22=" \047=0x27='
                                //double plon_min,plon_sec;
                                plon_min=60*(plon-floor(plon));
                                plon_sec=60*(plon_min-floor(plon_min));
                                sprintf(printbuf,"%c%3.0f\260%02.0f\047%02.0f\042",  EW, floor(plon), floor(plon_min), plon_sec);
                        break;
                        default :
                                sprintf(printbuf,"%c%8.4f", EW,plon);
                        break;
                	}

			draw_string (printbuf ,404,225);

		}
		blitAlphaImageToScreen(0,0,80,34,sideplate,400,238);
		int slide=satellites-2;
		if (slide<0) slide=0;
		if (slide>6) slide=6;
		blitAlphaImageToScreen(slide*30,0,30,10,signalbar,410,256);
		if (scePowerGetBatteryLifePercent()<=100 && scePowerGetBatteryLifePercent()>0)
			blitAlphaImageToScreen(((100-scePowerGetBatteryLifePercent())/25)*16,0,16,10,battery,456,256);
		else
			blitAlphaImageToScreen(0,0,16,10,battery,456,256);
		int hours=ltime/10000+timezone;
		if (hours<0) hours+=24;
		if (hours>23) hours-=24;
		sprintf(printbuf,"%02d:%02ld:%02ld",   hours,ltime%10000/100,ltime%100);
		draw_string (printbuf,408,244);

	}  
	alerttimer++;
	if ( speed*speedfix<speedlimit ) duration=0;
	if (speedlimit>0 && speed*speedfix>speedlimit && alerttimer>50/(333/Clock) && duration<50) {
		if (duration==0) 
			playfile("speedlimit.mp3");
		duration++;
		if (duration>48)  {
			alerttimer=-100;
			duration=0;
		}
       		display_message_no_block("","SPEED WARNING!","");
	}
	}
	} //showpanels
		
	if (strlen(attrbuf1)>0 && atimer>3/(333/Clock)) {
		display_alert(attrbuf1,attrbuf2);	
	}
	if (gpsout!=NULL)
		draw_red_string ("REC: ON",27-gpsOn*20,20-gpsOn*15);
	flipScreen();
	if (gpsOn) {
		if (mx<1 && my<1) {
			mx=(double)mapx;
			my=(double)mapy;

		}
		frameDelta=frameTick;
		sceRtcGetCurrentTick(&frameTick);
		frameDelta=frameTick-frameDelta;
		//fprintf(stdout,"deltax:%f factor:%f deltax/:%f\n",deltax,speedfactor,deltax/avgframes);
		mx+=deltax/avgframes;
                my+=deltay/avgframes;
		deltax*=speedfactor;
		deltay*=speedfactor;
		mapx=(long)mx;
		mapy=(long)my;

		//sceKernelDelayThread(10000);
		getGPSMessage();
	}
	sceKernelDelayThread(2);
	}
	if (gpsout!=NULL) {
		fclose(gpsout);
		gpsout=NULL;
	}
	beep();
	zm++;
	idle=1;
	while (tlock==1) 
		sceKernelDelayThread(1);
	tlock=1;
	unload_group(4096,zipfile,datatype);
        imglist_garbagecollect();
	tlock=0;
	sceKernelDelayThread(500000);
	safe_map_prefs (mapx,mapy,  zoom); 

	if (datatype==1)
		gpsfsClose();
	if (attr_flag==1) 
              turn_off_attractions();
	}
	running=0;
	cleanup_output();
#ifdef GENERIC
  	sceKernelExitDeleteThread(0);
#endif
        sceKernelExitGame();
	return 0;

}



