#include <pspdebug.h>
#include <psppower.h>
#include <pspsdk.h>
#include <stdio.h>
#include <string.h>
#include "graphics.h"
#include <zlib.h>
#include <stdlib.h>
#include <pspctrl.h>
#include <dirent.h>
#include <math.h>
#include <psprtc.h>
#include <pspnet_apctl.h>
#include <pspnet_inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/unistd.h>
#include <psputility.h>
#include <errno.h>
#include <sys/stat.h>
#include <pspsyscon.h>

#include "version.h"


#define PSP_WIDTH       480
#define PSP_HEIGHT      272
#define RADIUS          18
#define PATHMAX         4000 
#define TILE_SIZE       256
#define STDOUT_FILE     "stdout.txt"
#define STDERR_FILE     "stderr.txt"
#define PI              3.14159265358979326433



typedef struct
{
        double lon;
        double lat;
        double latHeight;
        double lonWidth;
} Coord;

#define MAXZIP   80
typedef struct  {
        char zipcode[6];
        char street[63];
        char city[31];
        char state[3];
        double lat;
        double lon;
	double dist;
	double bearing;	
	int num;	
} ADDRESS;

char currentpath[128];


/* Define some important parameters, not really sure on names. Probably doesn't matter */
#define PSP_UART4_FIFO 0xBE500000
#define PSP_UART4_STAT 0xBE500018
#define PSP_UART4_DIV1 0xBE500024
#define PSP_UART4_DIV2 0xBE500028
#define PSP_UART4_CTRL 0xBE50002C
#define PSP_UART_CLK   96000000
#define PSP_UART_TXFULL  0x20
#define PSP_UART_RXEMPTY 0x10
int sceHprmEnd(void);
int sceSysregUartIoEnable(int uart);
int sceSyscon_driver_44439604(int power);



void initLatLon(); 
void toUpperCase(char * str);
Coord getLatLong(int x, int y, int zoom);
Coord getXY(double lat, double lon, int zoomLevel );
int powerOf(int p);
Image* ldImage(const char* filename);
Image* ldImage1(const char* filename, int negate);
FILE * fopn(const char* path,const char* options);
#ifndef GENERIC
#include <pspuser.h>
#include "pspusbgps.h"
#include <pspusb.h>
int module_start (SceSize args, void *argp);
#else
#include <pspkernel.h>
#include <pspnet_resolver.h>
#endif
#include <pspnet_resolver.h>
#include <pspwlan.h>
